COMMENT ^

This is the header file for Protocol Manager and its clients.  It
contains request block structure for the Protocol Manager Primitives
(Request to the protocol manager), as well as error codes and opcode 
definitions.  

Note that error codes are in singluar domain.  And opcodes are in three 
different domains; PM primitives, Module System requests, and general 
MAC requests.

^

; Errors (Return status)
;---------------------------------------
SUCCESS                         equ     0000h
WAIT_FOR_CONFIRMATION           equ     0002h
OUT_OF_RESOURCE			equ	0003h
IMCOMPATIBLE_MODULE		equ	0005H
CANT_MULTIPLEX_MODULE		equ	0006H
INVLAID_PARAMETER		equ	000CH
INVALID_FUNCTION                equ     000Dh
UNSPECIFIED_ERROR               equ     00FFh

BINDING_LOOP_DETECTED		equ	0203H
INCOMPATIBLE_BINDING		equ	0205H

FRAME_NOT_RECOGNIZED		equ	0301H
FRAME_REJECTED			equ	0302H
FORWARD_FRAME			equ	0303H


; Module system request Opcodes
SYSOP_INITIATE_BIND		equ	1
SYSOP_BIND			equ	2	


; PM primitive opcodes
PMOP_GET_PROTO_MGR_INFO		equ	1
PMOP_REGISTER_MODULE		equ	2
PMOP_BIND_AND_START		equ	3

 
; MAC General request opcodes
MACOP_INITIATE_DIAGNOSTICS	equ	1
MACOP_READ_ERROR_LOG		equ	2
MACOP_SET_STATION_ADDRESS	equ	3
MACOP_OPEN_ADAPTOR		equ	4
MACOP_CLOSE_ADAPTOR		equ	5
MACOP_RESET_MAC			equ	6
MACOP_SET_PACKET_FILTER		equ	7
MACOP_ADD_MUTILCAST_ADDRRESS	equ	8
MACOP_DEL_MULTICAST_ADDRESS	equ	9
MACOP_UPDATE_STATISTICS		equ	10
MACOP_CLEAR_STATISTICS		equ	11
MACOP_INTERRUPT			equ	12
MACOP_SET_FUNCTIONAL_ADDRESS	equ	13
 

; Request Block structure 
;---------------------------------------
ReqBlock_s	struc
	rb_opcode	dw	?	; Opcode
	rb_status	dw	?	; return status
	rb_pointer1	dd	?	; parameter pointer 1
	rb_pointer2	dd	?	; parameter pointer 2
	rb_word1	dw	?	; parameter word 1
ReqBlock_s	ends

