;
; <<==++ Copyright (c) Microsoft Corporation  1986 ++==>> \
;
;**	Device Table Record
;
;	Devices are described by a chain of these records
;==============================================================================
;		       STRUCTURE NAME --- SysDev
;------------------------------------------------------------------------------
; Structure map to Device header
SysDev	STRUC
SDevNext	DD	?	; Pointer to next device header
SDevAtt 	DW	?	; Attributes of the device
SDevStrat	DW	?	; Offset to Strategy entry point
		DW	?	; Reserved
SDevName	DB	'        '
		; Name of device (only first byte used for block)
SProtCS 	DW	?	; protected mode CS
SProtDS 	DW	?	; protected mode DS
SRealCS 	DW	?	; real mode CS
SRealDS 	DW	?	; real mode DS
SysDev	ENDS
;------------------------------------------------------------------------------
;**	Device Driver Type defininitions
;------------------------------------------------------------------------------
;The attribute of device header
DEV_CIN 	EQU 0000000000000001B ;  0  2 5 Device is console in
DEV_COUT	EQU 0000000000000010B ;  1  2 5 Device is console out
DEV_NULL	EQU 0000000000000100B ;  2  2 5 Device is the Null device
DEV_CLOCK	EQU 0000000000001000B ;  3  2 5 Device is the clock device
;		EQU 0000000000010000B ;  4	special
;		EQU 0000000000100000B ;  5
DEV_GIOCTL	EQU 0000000001000000B ;  6   3	Device supports generic ioctl
DEV_FCNLEV	EQU 0000001110000000B ; 9-7   5 Device function level
;		    0000010000000000B ; 10	reserved
DEV_30		EQU 0000100000000000B ; 11  2 5 Accepts Open/Close/Removable Media
;		    0001000000000000B ; 12	reserved
DEV_NON_IBM	EQU 0010000000000000B ; 13  2 5 Device is a non IBM device.
DEV_SUP_IOCTL	EQU 0100000000000000B ; 14  14	Device supports IOCTL (DOS)
DEV_CHAR_DEV	EQU 1000000000000000B ; 15  2 5 Device is a character device
;------------------------------------------------------------------------------
;	Level definitions for devices
;		    0000001110000000B	; Device function level
DEVLEV_0    EQU     0000000000000000B	; DOS 3.0 and before (NEEDS TO BE FIXED)
DEVLEV_1    EQU     0000000010000000B	; DOS 5.0
