;
; <<==++ Copyright (c) Microsoft Corporation  1986 ++==>>
;

IFDEF DEBUGDEV     ; with DEBUGDEV
  DEBUG = 1
ELSE               ; without DEBUGDEV
  DEBUG = 0
ENDIF

;   Turn off listing for standard include files
.xlist
        INCLUDE DEVHLP.INC
        INCLUDE DEVSYM.INC
        INCLUDE ERROR.INC
        INCLUDE INFOSEG.INC
.list

WO      EQU     WORD PTR
BY      EQU     BYTE PTR

; ALLOC_MEM_LOW   EQU 1
; ALLOC_MEM_HIGH  EQU 0

STDIN           EQU       0     ;Standard input  device
STDOUT          EQU       1     ;Standard output device
MemBufSz        EQU     256

;------------------------------------------------------------------------------
;                       STRUCTURE NAME --- LONG_PTR
;------------------------------------------------------------------------------
LONG_PTR STRUC
        _OFF    DW      (?)     ;Offset of far pointer
        _SEG    DW      (?)     ;Segment of far pointer
LONG_PTR ENDS
;------------------------------------------------------------------------------
;                      STRUCTURE NAME --- PHYSADDR
;------------------------------------------------------------------------------
PHYSADDR STRUC
        _LO     DW      (?)     ;Low word of a 32-bit pointer
        _HI     DW      (?)     ;High word of a 32-bit pointer
PHYSADDR ENDS
;------------------------------------------------------------------------------
;                        MACRO NAME --- DEVHELP
;------------------------------------------------------------------------------
; Call a Device Helper service. Assumes that DS is DD's data seg
;
DEVHELP MACRO   func
        mov     dl,DEVHLP_&func
        call    [DevHlp]
ENDM
;------------------------------------------------------------------------------
;       for DevHlp_GetDOSVar call
;------------------------------------------------------------------------------
DOSVar_SysInfo      EQU     1
DOSVar_LocInfo      EQU     2             ;LocINFOseg (1st word is CurPid)
DOSVar_ReBoot       EQU     5
DOSVar_YieldFlag    EQU     7
DOSVar_TCYieldFlag  EQU     8
;------------------------------------------------------------------------------
;       for SemHandle call
;------------------------------------------------------------------------------
NOT_IN_USE      EQU     0
IN_USE          EQU     1
;------------------------------------------------------------------------------
;       for PhysToVirt call
;------------------------------------------------------------------------------
ToDS_SI         EQU     0               ; Put result in DS:SI
ToES_DI         EQU     1               ; Put result in ES:DI
;------------------------------------------------------------------------------
;       for PhyToUvirt call
;------------------------------------------------------------------------------
ToUVirt_RE      EQU     0               ; Make segment read/execute
ToUVirt_RW      EQU     1               ; Make segment read/write
ToUVirt_Fre     EQU     2               ; Free virtual address
;------------------------------------------------------------------------------
;       for AllocPhys/FreePhys
;------------------------------------------------------------------------------
Mem_Hi          EQU     0               ; Allocate above 1mb
Mem_Lo          EQU     1               ; Allocate below 1mb
;------------------------------------------------------------------------------
;                     STRUCTURE NAME --- LOCALDATA
;------------------------------------------------------------------------------
; Local Data Area
;   LocalData structure is allocated on the stack and intialized by the
;   Strategy routine for each device driver instance.
;
LOCALDATA STRUC
    LD_PTRSAVE  DD   (?)                ; Far pointer to the request header
LOCALDATA ENDS
;------------------------------------------------------------------------------
;                         MACRO NAME --- SLEEP
;------------------------------------------------------------------------------
; common macros to sleep/wake up

SLEEP   MACRO   EVENT_ID
        MOV     BX,WORD PTR EVENT_ID
        MOV     AX,WORD PTR EVENT_ID[2]
        MOV     DI,-1           ; no time-out
        MOV     CX,DI
        MOV     DH,0            ; sleep is non-interruptible
        DEVHELP BLOCK           ; block on event
        ENDM
;------------------------------------------------------------------------------
;                         MACRO NAME --- READY
;------------------------------------------------------------------------------
READY   MACRO   EVENT_ID
        MOV     BX,WORD PTR EVENT_ID
        MOV     AX,WORD PTR EVENT_ID[2]
        DEVHELP RUN             ; unblock process
        ENDM
