COMMENT  ^
################################################################################

  Title:	RTL8139 NDIS 2.x Driver

  History:	V0.00  --   05/09/1997

  Notes:	The driver executable file(RTSND.DOS) should be used with
		the OEMSETUP.INF file which will be released later on.
		Therefore, no [EXE] directory is build to prevent confusion.
		However, the driver executable file still can be found
		under [SOURCE] directory.

################################################################################




  Name: 	 RTSND.DOS

  Version:	 V0.00

  Released By:	 JACK

  Release Date:  05/09/97

  Changed File:


  Reason:
	       NEW

********************************************************************************

  Name: 	 RTSND.DOS

  Version:	 V1.00

  Released By:	 JACK

  Release Date:  06/15/97

  Changed File:


  Reason:
	       add parameter and fix imr value (3fh)

********************************************************************************

  Name: 	 RTSND.DOS

  Version:	 V2.00

  Released By:	 JACK

  Release Date:  08/21/97

  Changed File:  Transmit.asm
		 Init.asm

  Reason:
	       RTL8139 Fast Ethernet Single Chip 100/10 F version
	       add polling for ML6692 Hub

********************************************************************************
  Name: 	 RTSND.DOS,RTSND.OS2

  Version:	 V2.50

  Released By:	 JACK

  Release Date:  10/30/97

  Changed File:
		 Init.asm

  Reason:
		Add keyword parameter and 9346 register keyword

********************************************************************************


  Name: 	 RTSND.DOS,RTSND.OS2

  Version:	 V3.00

  Released By:	 KEN

  Release Date:  01/15/98

  Changed File:
		 Init.asm ,request.asm

  Reason:
		 Fix the bug for the Pentium Pro CPU in the heavy traffic.

********************************************************************************



  Name: 	 RTSND.DOS,RTSND.OS2

  Version:	 V3.10

  Released By:	 Jack Chen

  Release Date:  03/30/98

  Changed File:
		 ALL Files

  Reason:

********************************************************************************

  Name: 	 RTFND.DOS

  Version:	 V3.21

  Released By:	 JACK

  Release Date:  01/07/99

  Changed File:
		INIT.ASM
		INT.ASM

  Reason:
		1.Selectable TxFiFo Threshold 0 - 31 value.
		2.save high word register in int.asm ,transmit.asm
		3.cover the IMR register when it run in rpl server.

********************************************************************************



The board supports a Bus Master data transfers and PCI target I/O transfers.
We need to get the IOBase and IRQ from PCI Configuration Space Register.

Hardware characteristics:
   PCI local bus single-chip Fast Ethernet Controler.Compliant 2.1,support two
network port:10Mb/s and 100Mb/s.

^
   ;******** Comment delimiter ^  ^ [[text]] ********

include macros.inc
include vector.inc
include os2defs.inc
include dp8139.inc
include rtl8139.inc
include pmgr.inc
include dosopen.inc
include devhdr.inc
include bit.inc
  ;********* Include *.inc files (os/2 , RTL8139 need to use) ********

IFNDEF	DOS				;286 protected mode needed to
.286P					;examine machine status word
ENDIF					;under OS/2

BAD_ARG 		equ	1	;unknown argument
BRD_NOT_FOUND		equ	2	;board not found
INT_ERR 		equ	3	;interrupt conflict
INTERNAL_ERR		equ	4	;internal error
GDT_ERR 		equ	5	;GDT allocation failed
PROTMGR_ERR		equ	6	;protocol mgr. open failed
REG_ERR 		equ	7	;registration failed
PMGR_IOCTL_FUNC 	equ	58h
PMGR_CATEGORY		equ	81h


;-----------------------  ***** DATA Segment Begin *****-----------------------
DATASEG_BEG

EXTRN	ServChar:WORD, DriverHead:WORD, CommChar:WORD, ServStat:WORD
EXTRN	IRQ:WORD, BrdNum:BYTE,NetAddr:word,NetAddress:word,NetFlag:byte
EXTRN	DriverName:byte

;OtherGDT must directly follow boardseg since they are allocated in the
;same call

Public	Device_Help
Public	SegTX
Public	SegRX


Device_Help	dd	?		; address of device help gate
SegTX		dw	0		; GDT selector for transmit
SegRX		dw	0		; GDT selector for receive
TempUsedSel	dw	?		; a temp selector
OtherGDT	dw	?		; temporary GDT


;********************************************************************
;*		      RTL8139  Data Area			    *
;*								    *
;*			 DOS & OS2				    *		 *
;********************************************************************

;;;;;;;;;;;;;;;;;;;;;v200 8139;;;;;;;;;;;;;;;;;;;;;;;;;;
PARAM70  equ	 0020h
PARAM74  equ	 003c0h
PARAM78  equ	 078fa8388h
PARAM7C  equ	 0cb38de43h

p1_8139 dd	0cb39de43h,  0cb39de43h,  2h, 0cb39de43h,  4h,	5h,  6h,  0bb39de43h,  8h
p2_8139 dd	0cb39ce43h,  0cb39ce43h,  2h, 0cb39ce43h,  4h,	5h,  6h,  0bb39ce43h,  8h
p3_8139 dd	0cb39ce83h,  0cb39ce83h,  2h, 0cb39ce83h,  4h,	5h,  6h,  0bb39ce83h,  8h
p4_8139 dd	0cb39ce83h,  0cb39ce83h,  2h, 0cb39ce83h,  4h,	5h,  6h,  0bb39ce83h,  8h

p1_delay dd	(333d)/10,  (333d)/10,	2,  (333d)/10,	4,  5,	6,  (333d)/10,	8
p2_delay dd	(333d)/10,  (333d)/10,	2,  (333d)/10,	4,  5,	6,  (333d)/10,	8
p3_delay dd	(333d)/10,  (333d)/10,	2,  (333d)/10,	4,  5,	6,  (333d)/10,	8
p4_delay dd	(333d)/10,  (333d)/10,	2,  (333d)/10,	4,  5,	6,  (333d)/10,	8


;;;;;;;;;;;;;;;;;;;;v200 8139;;;;;;;;;;;;;;;


public Sub_Vender_ID,Force_flag,Medium

;Force_100	db	0
;Force_10	db	0
Duplex		db	0	;1:ful duplex, 0:half duplex
Medium		db     -1	;first check keyword parameter then 9346 value
Force_flag	db	0
Sub_Vender_ID	db	12 dup(?)
IDFlag		db	0
SlotFlag	db	0
dw_pci_bdfnum	dd	00000000h

count		dw	0

NumOf8139	dw	0

IOBuffer	dw	20  dup(0)

IRQBuffer	db	20  dup(0)

ID_Buffer	db	80 dup(0),13,10 ,'$'
ID_USER 	db	6 dup(0)

BUSNO		dw	?
BUS_DEV_NUM	dw	?		;LBtest used

SlotBuffer	db	8 dup (0)

DriverString	db	'DRIVERNAME', 0

RTF10MHalfMsg	 db 'Network Line Speed is 10 Mbps / Half_Duplex Mode  ',13,10
RTF10MHalfMsgLen   =	   $ - RTF10MHalfMsg

RTF10MFullMsg	 db 'Network Line Speed is 10 Mbps / Full_Duplex Mode  ',13,10
RTF10MFullMsgLen   =	   $ - RTF10MFullMsg

RTF100MHalfMsg	  db 'Network Line Speed is 100 Mbps / Half_Duplex Mode  ',13,10
RTF100MHalfMsgLen   =	    $ - RTF100MHalfMsg

RTF100MFullMsg	  db 'Network Line Speed is 100 Mbps / Full_Duplex Mode  ',13,10
RTF100MFullMsgLen   =	    $ - RTF100MFullMsg


AutoModeMsg	db 'TP/CX auto detect ! ',13,10
AutoModeMsgLen	 =	 $ - AutoModeMsg

LinkFailMsg	db 'Warning ! The Cable may be DisConnected ! ',13,10
LinkFailMsgLen	 =	 $ - LinkFailMsg

BaseTModeMsg	db '10 BaseT !    ',13,10
BaseTModeMsgLen   =	  $ - BaseTModeMsg

Base2ModeMsg	db '10 Base-2 !    ',13,10
Base2ModeMsgLen   =	  $ - Base2ModeMsg

Base5ModeMsg	db '10 Base-5 !    ',13,10
Base5ModeMsgLen   =	  $ - Base5ModeMsg

HardWareErrorMsg	db 'HardWare Error !!!! ',13,10
HardWareErrorMsgLen   =       $ - HardWareErrorMsg

FORCE100Msg	db 'Force 100M !    '
FORCE100MsgLen	 =	 $ - FORCE100Msg

FORCE10Msg	db 'Force 10M !    '
FORCE10MsgLen	=	$ - FORCE10Msg

FullDuplexMsg	db 'Full Duplex !    ',0dh,0ah
FullDuplexMsgLen   =	   $ - FullDuplexMsg

HalfDuplexMsg	db 'Half Duplex !    ',0dh,0ah
HalfDuplexMsgLen   =	   $ - HalfDuplexMsg


FORCEErrMsg	db 'Detected H/W Error  !!!! ',13,10
FORCEErrMsgLen	 =	 $ - FORCEErrMsg

No8139DosMsg	db 'No Fast Ethernet PCI Adapter Found!',20 dup(20h),13,10
		db 'Driver Not Loaded.',13,10
No8139DosMsgLen  =	 $ - No8139DosMsg

Multi8139IDMsg	db 'More than one Fast Ethernet PCI adapters have been detected!'
		db 20 dup(20h),13,10
		db 'ID comparing......',13,10
Multi8139IDMsgLen =	  $ - Multi8139IDMsg

Multi8139SlotMsg  db 'More than one Fast Ethernet PCI adapters have been detected!'
		db 20 dup(20h),13,10
		db 'BUSNO , DEVICENO comparing......',13,10
Multi8139SlotMsgLen =	    $ - Multi8139SlotMsg

IDNotMatchMsg	db   'Warnning:--- Can not find [ETHERID] in PROTOCOL.INI '
	   db	'  or can not find',13,10
	   db	'             one that match.',13,10
	   db	'             Driver can not determine which one to use.',13,10
	   db	'Solution:---',13,10
	   db	'  Please specify and check adapter ID in PROTOCOL.INI file.'
	   db	13,10,13,10
	   db	'  [Example]:  [XXXXXXX]        ',10,13
	   db	'              ETHERID = @0123456789AB ',10,13,10,13
IDNotMatchMsgLen   =	   $ - IDNotMatchMsg


SlotNotMatchMsg  db   'Warnning:--- Can not find [BUSNO] [DEVICENO] in PROTOCOL.INI '
	   db	'  or can not find',13,10
	   db	'             one that match.',13,10
	   db	'             Driver can not determine which one to use.',13,10
	   db	'Solution:---',13,10
	   db	'  Please specify and check keyword in PROTOCOL.INI file.'
	   db	13,10,13,10
	   db	'  [Example]:  [XXXXXXX]        ',10,13
	   db	'                BUSNO =    ',10,13
	   db	'                DEVICENO =    ',10,13
SlotNotMatchMsgLen   =	     $ - SlotNotMatchMsg

   DMA_DESCRIPTOR  STRUC
	   RegionSize	   DD	   0
	   RegionOffset    DD	   0
	   RegionSegment   DW	   0
	   BufferID	   DW	   0
	   PhysicalAddress DD	   0
   DMA_DESCRIPTOR  ENDS

  Align 4
  TXDmaDescriptor0	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor1	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor2	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor3	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor4	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor5	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor6	  DMA_DESCRIPTOR  <>
  TXDmaDescriptor7	  DMA_DESCRIPTOR  <>

  RXDmaDescriptor	  DMA_DESCRIPTOR  <>

public TxStartAddrPage0   , RxBufferStartAddr
public TxStartAddrPage1   , TxStartAddrPage2 , TxStartAddrPage3
public TxStartAddrPage4   , TxStartAddrPage5 , TxStartAddrPage6
public TxStartAddrPage7

public pTxStartAddrPage1   , pTxStartAddrPage2 , pTxStartAddrPage3
public pTxStartAddrPage4   , pTxStartAddrPage5 , pTxStartAddrPage6
public pTxStartAddrPage7   , pTxStartAddrPage0

pTxStartAddrPage0	dd	0
pTxStartAddrPage1	dd	0
pTxStartAddrPage2	dd	0
pTxStartAddrPage3	dd	0
pTxStartAddrPage4	dd	0
pTxStartAddrPage5	dd	0
pTxStartAddrPage6	dd	0
pTxStartAddrPage7	dd	0

public TxBurstDMA,RESV1,RESV2,RxBurstDMA,RESV3
Public	NICIDR0 , NICIDR4 , NICCMD , NICRBSTART , NICCAPR , NICRCR
Public	NICIMR	, NICCR9346 , NICCAPR , NICERBCR , NICCONFIG0 , NICERSR
Public	NICISR	, NICTCR , NICTSD0 , NICTSD1 , NICTSD2 , NICTSD3
Public	NICTSAD0 , NICTSAD1 , NICTSAD2 , NICTSAD3
Public	NICTSAD ,NICGEP  ,NICCONFIG1,NICMAR0,NICMAR4

			align 4



RxBufferStartAddr	db 1024*8    dup (?)  ;Rx Buffer Start Address
			db 1600      dup (?)  ;Rx Buffer overrun
			db 16	     dup (?)  ;Redundant

TxStartAddrPage0	db 1600d dup (?)   ;Tx Page0 Buffer Start Address
TxStartAddrPage1	db 1600d dup (?)   ;Tx Page1 Buffer Start Address
TxStartAddrPage2	db 1600d dup (?)   ;Tx Page2 Buffer Start Address
TxStartAddrPage3	db 1600d dup (?)   ;Tx Page3 Buffer Start Address
TxStartAddrPage4	db 1600d dup (?)   ;Tx Page0 Buffer Start Address
TxStartAddrPage5	db 1600d dup (?)   ;Tx Page1 Buffer Start Address
TxStartAddrPage6	db 1600d dup (?)   ;Tx Page2 Buffer Start Address
TxStartAddrPage7	db 1600d dup (?)   ;Tx Page3 Buffer Start Address

TxBurstDMA	dw	0600h		    ;Max DMA burst
TxFiFo		dd	00000000h

RESV1		dd     000A0000h
					    ;default value = 0A (320 byte)

RxBurstDMA	dw     0600h		    ;Max DMA burst

RESV2		dd     08000000h

RESV3		dd     00004000h


	NICIDR0 	dw	?		;00h
	NICIDR4 	dw	?		;04h
	NICMAR0 	dw	?		;08h
	NICMAR4 	dw	?		;0Ch
	NICTSD0 	dw	?		;10h
	NICTSD1 	dw	?		;14h
	NICTSD2 	dw	?		;18h
	NICTSD3 	dw	?		;1Ch
	NICTSAD0	dw	?		;20h
	NICTSAD1	dw	?		;24h
	NICTSAD2	dw	?		;28h
	NICTSAD3	dw	?		;2Ch
	NICRBSTART	dw	?		;30h
	NICERBCR	dw	?		;34h
	NICERSR 	dw	?		;36h
	NICCMD		dw	?		;37h
	NICCAPR 	dw	?		;38h
	NICIMR		dw	?		;3Ch
	NICISR		dw	?		;3Eh
	NICTCR		dw	?		;40h
	NICRCR		dw	?		;44h
	NICTCTR 	dw	?		;48h	Timer CounT Register
	NICMPC		dw	?		;4Ch	Missed Packet Counter
	NICCR9346	dw	?		;50h
	NICCONFIG0	dw	?		;51h
	NICCONFIG1	dw	?		;52h
						;53h	reserved
	NICFLASH	dw	?		;54h
	NICGEP		dw	?		;58h
	NICGEPCTL	dw	?		;59h
	NICMIIR 	dw	?		;5Ah
	NICMII0 	dw	?
	NICHLTCLK	dw	?		;5Bh
	NICMULINT	dw	?		;5Ch
						;5Eh,5Fh reserved
	NICTSAD 	dw	?		;60h
						;62h - 6fh : reserved
	NICFIFOTMS	dw	?		;70h - 73h FIFO test mode select

	NICFIFOTMD	dw	?		;74h - 77h FIFO test read/write data
						;78h - 7Eh reserved
	NICCLRCACHE	dw	?		;7Fh: clear cache (PCS mode)

Public CurRxBufAddr, DataPrefetchFlag
CurRxBufAddr		dw	0000h		;Current rx buffer address
DataPrefetchFlag	db	0


 ;***********************************************
 ;*    (Display in DOS Message & Data Area)	*
 ;***********************************************

 ; IFDEF DOS


LoadingDosMsg	db 13,10,'Loading Fast Ethernet Network Adapter ',13,10
LoadingDosMsgLen =	 $ - LoadingDosMsg

PCI_ERR 	db   'It s not PCI SYSTEM BIOS , so can t not running ! ',13,10
PCI_ERRLen	=   $ - PCI_ERR


	;***** M1 / M2 PCI BIOS Function call values *****

PCI_BIOS_INT_ADDR	EQU  0FFE6Eh	; for "call" to int 1Ah
DEVHLP_PHYSTOVIRT	equ	15h
UVIRT_RE		equ	0

PCI_FUNCTION_ID 	equ	0B1h
PCI_BIOS_PRESENT	equ	01h
FIND_PCI_DEVICE 	equ	02h
READ_CONFIG_BYTE	equ	08h
READ_CONFIG_WORD	equ	09h
READ_CONFIG_DWORD	equ	0ah
WRITE_CONFIG_BYTE	equ	0Bh
WRITE_CONFIG_WORD	equ	0ch
WRITE_CONFIG_DWORD	equ	0dh
GET_IRQ_ROUTING_OPTIONS equ	0Eh
SUCCESSFUL		equ	00h
FUNC_NOT_SUPPORT	equ	81h
BAD_VENDOR_ID		equ	83h
DEVICE_NOT_FOUND	equ	86h
BAD_REGISTER_NUMBER	equ	87h
SET_FAILED		equ	88h
BUFFER_TOO_SMALL	equ	89h


 ;***********************************************
 ;*    (Display in OS/2 Message & Data Area)	 *
 ;***********************************************

; ELSE

LoadingOS2Msg	db 13,10,'Loading Fast Ethernet Network Adapter  ',13,10
LoadingOS2MsgLen   =	$ - LoadingOS2Msg

RTL_VENDOR_ID	equ	10ECh		; RTL8139 vender ID
RTL_PCI_ID	equ	8139h		; RTL8139 device ID

PCI_MAX_BNUM	equ	8		; maxi. PCI bus #
PCI_M1MAX_DNUM	equ	32		; maxi. PCI M1 device #
PCI_M2MAX_DNUM	equ	16		; maxi. PCI M2 device #
PCI_MAX_FNUM	equ	8		; maxi. PCI function #

PCI_CAD_REG	equ	0CF8h		; PCI M1 config. addr register
PCI_CDA_REG	equ	0CFCh		; PCI M1 config. data register
PCI_CSE_REG	equ	0CF8h		; PCI M2 config. space enable register
PCI_CFW_REG	equ	0CFAh		; PCI M2 config. forward register

PCI_CBUS_BIT	equ	16		; PCI M1 config. bus # bit position
PCI_CDEV_BIT	equ	11		; PCI M1 config. device # bit position
PCI_CFUN_BIT	equ	 8		; PCI M1 config. function # bit position
PCI_DEVID_BIT	equ	16		; PCI device ID bits

PCI_M1_ENABLE	equ	80000000h	; PCI M1 enable bit
PCI_M2_ENABLE	equ	80h		; PCI M2 enable bit

PCI_CFG_ADDR	equ	0C000h		; PCI M2 config. space address
PCI_CFDEV_OFF	equ	100h		; PCI M2 cfg. space device offset
PCI_CSFUN_BIT	equ	1		; PCI M2 cfg. space fun # bit position

PCI_DEVID_OFF	equ	02h		; device ID offset in cfg. space header
PCI_BAREG_OFF	equ	10h		; PCI base address register offset
PCI_CDREG_OFF	equ	04h		; PCI command register offset
PCI_STREG_OFF	equ	06h		; PCI status register offset
PCI_SUBID_OFF	equ	2Eh
PCI_ITREG_OFF	equ	3Ch		; PCI interrupt register offset
PCI_CFG3C	equ	3Ch		; PCI config register 3Ch

PCI_CREG_DEF	equ	0145h		; command
PCI_SREG_DEF	equ	0FFFFh		; status

PCI_NULL_DEV	equ	0FFFFh		; no PCI device exist


GG_IO_BASE_MASK equ	0FFFEh		; mask off bit 0(stuck high)


;ENDIF

DataSegEnd	dw	?			;end of data segment
DATASEG_END
;-----------------------  ***** DATA Segment END ***** -------------------------

;-----------------------  ***** CODE Segment Begin ***** -----------------------

CODESEG_BEG

EXTRN	IntCheck:NEAR
EXTRN	IOBase:WORD

PUBLIC cs_ds
cs_ds		dw	?			 ;GDT for PHYSTOGDT calls

;extrn show_char:near,show_char1:near

lbkpaclen	 dw ?


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;input bx;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Public	set_param
set_param:
	push	eax
	push	edx
	mov	ax,4
	mul	bx
	mov	bx,ax
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	eax,p1_8139[bx]
;	loadport
;	setport RTL_7C

	push	eax
	mov	eax,00000000h
	mov	dx, (DS:NICIDR0)
	add	dx, 070h

	out	dx,eax
	pop	eax


	mov	dx, (DS:NICIDR0)
	add	dx, 07Ch

	out	dx,eax

	mov	eax,p1_delay[bx]
	call wait_pci

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	mov	eax,p2_8139[bx]
;	loadport
;	setport RTL_7C


	mov	dx, (DS:NICIDR0)
	add	dx, 07Ch

	out	dx,eax

	mov	eax,p2_delay[bx]
	call wait_pci
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	mov	eax,p3_8139[bx]
;	loadport
;	setport RTL_7C

	mov	dx, (DS:NICIDR0)
	add	dx, 07Ch

	out	dx,eax

	mov	eax,p3_delay[bx]
	call wait_pci

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	eax,p4_8139[bx]
;	loadport
;	setport RTL_7C

	mov	dx, (DS:NICIDR0)
	add	dx, 07Ch

	out	dx,eax

	mov	eax,p4_delay[bx]
	call wait_pci

	pop	edx
	pop	eax
	ret



;;;;;;;;;;;;;;;;;;;;;v200 8139;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;input: eax (it will dalay eax*30ns );;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	Public wait_pci
wait_pci:
	push	eax
	push	ebx
	push	ecx
	push	edx

	mov	dx,cs:IOBase
	add	dx,TCTR
	out	dx,eax
	mov	ebx,eax
wait_pci_1:
	in	eax,dx
	cmp	eax,ebx
	jbe	wait_pci_1     ;eax < ebx
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	ret


CodeSegEnd	dw	?			;end of code segment


CODESEG_END
;-----------------------  ***** CODE Segment END  ***** -----------------------
;
;-------------------  ***** Inital DATA Segment Begin ***** -------------------

INITDATASEG_BEG

;variables for open call
filehandle	dw	?
action		dw	?	      ;

protdev 	db	'PROTMAN$',0  ;Protocol device

EVEN

   ;configuration variables

   ;flag for bypassing protocol manager
   ;0 -> use PM, 1 -> bypass PM 	  ;flag inidicate use PM or not ?
bypass		dw	0

   ;verbose flag: 1 -> print parameters. 0 -> don't
verbose 	dw	0	       ;print message ?

   ;protocol manager request block
protreq 	ReqBlock	<>     ;protocol request block

   ;*** parameter string ***
parammess	db	'Parameters: IOBase           = 0x'
IObasestr	db	'000'
		db	0dh,0ah
		db	'            Interrupt Level  = '
Intstr		db	' 0'
		db	0dh,0ah
paramlen	=	$ - parammess


   ;*** RTL8139 installation successful message ***
goodmess	db	'Fast Ethernet Adapter driver '
		db	'(V3.24) [10/23/02]'
		db	' is installed',20 dup(20h), 0dh,0ah
goodlen 	=	$ - goodmess

errmess 	db	'Fast Ethernet Adapter driver '
		db	'(V3.24) [10/23/02]'
		db	' installation failed'
		db	20 dup(20h),0dh,0ah
errlen		=	$ - errmess

   ;*** Waiting for key message ***
cntmess 	db	'Hit any key to continue...'
cntlen		=	$ - cntmess

   ; parameters for parsing image file
MemoryImagePtr	dd	0
MemoryImagePtr2 dd	0
ImageIntString	db	 'INTERRUPT', 0
ImageIOString	db	 'IOBASE', 0

ImageTxFiFoString  db	 'TXFIFO', 0            ; 05/07/98
ImageIDString  db	 'ETHERID', 0        ; 09/16/96
ImageNetString	 db	 'NETADDRESS', 0           ; 09/16/96
ImageBusString	db	 'BUSNO' , 0            ; 07/04/96
ImageDeviceString db	 'DEVICENO' , 0         ; 07/04/96

ImageMediumString db	  'MEDIUM', 0           ; 10/24/97
ImageAutoString db	  '_AUTO' , 0            ; 10/24/97
Image10HalfString db	  '_10HALF' , 0          ; 10/24/97
Image10FullString db	  '_10FULL' , 0          ; 10/24/97
Image100HalfString db	  '_100HALF' , 0         ; 10/24/97
Image100FullString db	  '_100FULL' , 0         ; 10/24/97

;add 97.1.22
BIOSServiceEntry	dd  ?			;call int 1Ah

YDriverName	db     0,0,0,0,0,0,0,0,0,0

devicehandle	 dw	 ?
xaction 	 dw	 ?	       ;

xDriverName	 db	 'RTSND'
		 db	 '$'
		 db	 0
		 db	 0
		 db	 0
xbnum1		 db	 '$'
		 db	 10 dup (0)

errdescr	dw	DGROUP:err1, err2 - err1
		dw	DGROUP:err2, err3 - err2
		dw	DGROUP:err3, err4 - err3
		dw	DGROUP:err4, err5 - err4
		dw	DGROUP:err5, err6 - err5
		dw	DGROUP:err6, err7 - err6
		dw	DGROUP:err7, err8 - err7


err1	 db	 " err1 ERROR ",0dh,0ah

err2	 db	 " Fast Ethernet  Adapter was not found in this system.   ",0dh,0ah

err3	 db	 " err3 ERROR ",0dh,0ah

err4	db	" Serious internal error !",0dh,0ah,0ah

err5	db	" The driver was unable to allocate GDT entries.",0dh,0ah,0ah

err6	db	" The driver was unable to open the Protocol Manager. Check that",0dh,0ah
	db	" the Protocol Manager is loaded before the Lan driver in",0dh,0ah
	db	" config.sys or config.os2.",0dh,0ah,0ah

err7	db	" Registration with the Protocol Manager failed.",0dh,0ah,0ah

err8   label   byte

EVEN



INITDATASEG_END
;-------------------  ***** Inital DATA Segment END ***** ---------------------

;-------------------  ***** Inital CODE Segment BEGIN **** --------------------

IFNDEF	DOS
EXTRN	DOSOPEN:FAR, DOSDEVIOCTL:FAR, DOSPUTMESSAGE:FAR,DOSCLOSE:FAR
ENDIF

INITCODESEG_BEG

EXTRN	Init_System:NEAR, Init_Tables:NEAR, Init_Strategy:NEAR, Init_Int:NEAR
EXTRN	Init_Receive:NEAR,Init_Request:NEAR ,Init_Transmit:NEAR,
EXTRN	RestoreTimer:NEAR, ResetNIC:near
EXTRN

IFDEF DOS					;DOS

COMMENT ^

----------------------------------------------------------------------------
$Name: DOSPUTMESSAGE - put a message on the screen
----------------------------------------------------------------------------

$Description:
This function is used in DOS to perform the function of DOSPUTMESSAGE in OS/2.
It takes the same arguments (on the stack) as the OS/2 call.
$

$Method:
$
^

;   Stack status
;
;		 |	     |___ bp
;	       2 |    bp     |
;	       2 |   Call    |___ bp+4
;	       2 |  Offset   |
;	       2 |  Segment  |___ bp+8
;	       2 |  Length   |
;	       2 |  StdOut   |
;		 +-----------+

L_PROC		DOSPUTMESSAGE
		push	bp
		mov	bp,sp		;setup stack
		mov	cx,[bp+8]	;length
		mov	bx,[bp+4]	;message offset
		mov	ah,2		;display output call
putloop:	mov	dl,[bx] 	;print string
		int	21h
		inc	bx
		loop	putloop
		pop	bp
		mov	ax,0
		ret	8
L_ENDP		DOSPUTMESSAGE

ENDIF

COMMENT ^

----------------------------------------------------------------------------
$;Name: IntToString - convert a number to a string$  2 -> '2'
----------------------------------------------------------------------------
$Description:
This routine takes a number in ax and converts it to a string. The base which
the number should be converted to is given in bx. The caller provides a buffer
for the string whose last character is pointed to by si.
$

$Method:
$
^

L_PROC		IntToString

lpst:		mov	dx,0		;high order word is 0
		div	bx		;remainder in dx is low order char
		add	dx,'0'          ;convert to number
		cmp	dx,'9'          ;was it 10 or more?
		jle	@F		;no
		add	dx,'A'-'0'-10   ;yes. use letter representation
					;dx-'0'-10+'A'
@@:		mov	[si],dl 	;put in string
		dec	si		;look at previous character
		cmp	ax,0		;are we done?
		jg	lpst		;no
		ret
L_ENDP		IntToString

COMMENT ^

----------------------------------------------------------------------------
$Name: HexStringToInt - convert a hex character string to a number$  A -> 10
----------------------------------------------------------------------------
$Description:
This routine takes a string representation of a hex number and converts
it to an integer. The string is pointed to by es:di. The result is returned
in dx:ax.(32 bit representation, DX -> HighWord, AX -> LowWord
$

$Method:
$
^

L_PROC		HexStringToInt
		mov	ax,0
		mov	dx,0
		mov	bx,0
hexbeg: 	mov	bl,ES:[di]	;get character
		cmp	bl, 'a'         ;'a'>'A'>'0'
		jl	@F		; < 'a'
		cmp	bl, 'f'
		jg	HexCharNotFound ;word not found
		add	bl, 0ah - 'a'   ;lower case hex
		jmp	hexcharfound
@@:		cmp	bl, 'A'         ; < 'A'
		jl	@F
		cmp	bl, 'F'
		jg	HexCharNotFound ;word not found
		add	bl, 0Ah - 'A'   ;upper case hex
		jmp	hexcharfound
@@:		cmp	bl, '0'         ; < '0'
		jl	HexCharNotFound ;word not found
		cmp	bl, '9'
		jg	HexCharNotFound ;word not found
		sub	bl, '0'         ;number
		jmp	hexcharfound

;unknown character found so we must be done
HexCharNotFound: ret

hexcharfound:	shl	dx,1		;shift dx:ax and add new character
		shl	ax,1		;multiply by 16
		adc	dx,0
		shl	dx,1
		shl	ax,1
		adc	dx,0
		shl	dx,1
		shl	ax,1
		adc	dx,0
		shl	dx,1
		shl	ax,1
		adc	dx,0
		add	ax,bx
		inc	di
		jmp	hexbeg

L_ENDP		HexStringToInt

COMMENT ^

----------------------------------------------------------------------------
$Name: DecStringToInt - convert a decimal character string to a number$
----------------------------------------------------------------------------
$Description:
This routine takes a string representation of a decimal number and converts
it to an integer. The string is pointed to by es:di. The result is returned
in dx:ax.
$

$Method:
$
^
L_PROC		DecStringToInt
		push	si
		mov	cx,0		;store result in si:cx
		mov	si,0
		mov	bx,0
decbeg: 	mov	bl,ES:[di]	;get character
		cmp	bl, '0'
		jl	@F
		cmp	bl, '9'
		jg	@F
		sub	bl, '0'         ;number
		jmp	deccharfound

;unknown character found so we must be done
@@:		mov	dx,si
		mov	ax,cx
		pop	si
		ret

deccharfound:	mov	ax,si		;multiply current result by 10
		mov	dx,10
		mul	dx
		mov	si,ax		;ignore overflow
		mov	ax,cx		;multiply low order word
		mov	dx,10
		mul	dx
		add	si,dx
		mov	cx,ax
		add	cx,bx
		inc	di
		jmp	decbeg
L_ENDP		DecStringToInt

COMMENT ^

----------------------------------------------------------------------------
$Name: StringToInt - convert a character string to a number$
----------------------------------------------------------------------------
$Description:
This routine takes a string representation of a number and converts
it to an integer. The string is pointed to by es:di. The result is returned
in dx:ax.
$

$Method:
$
^
L_PROC		StringToInt
		mov	ax,0
		mov	dx,0
		cmp	BYTE PTR es:[di],'0'    ;is it a hex number
		jne	dodec
		cmp	BYTE PTR es:[di+1],'x'
		je	@F
		cmp	BYTE PTR es:[di+1],'X'
		jne	dodec
@@:		add	di,2
		call	HexStringToInt
		ret
dodec:		call	DecStringToInt
		ret
L_ENDP		StringToInt

COMMENT ^
----------------------------------------------------------------------------
$Name: ParseArgs - Parse command line arguments$
----------------------------------------------------------------------------
$Description:
This procedure parses the command line and checks the parameters.
It is called with ES:BX pointing to the initialization message.
$

$Method:
$
^
A_PROC		ParseArgs
		push	es
		push	bx
		push	di	   ;InitParms defined in devsym.inc
		les	di, ES:[bx].InitParms  ;get init arguments

;skip over the file of the driver. Look for first whitespace
skipdev:	cmp	BYTE PTR ES:[di],' '            ;is it a space
		je	skipwhite
		cmp	BYTE PTR ES:[di],9		;is it a tab
		je	skipwhite
		cmp	BYTE PTR ES:[di],0		;if null, then no args
		jne	@F
		jmp	argsdone
@@:		cmp	BYTE PTR ES:[di],0Ah		;if LF, then no args
		jne	@F
		jmp	argsdone
@@:		cmp	BYTE PTR ES:[di],0Dh		;if CR, then no args
		jne	@F
		jmp	argsdone
@@:		inc	di			;otherwise, look at next char

		jmp	skipdev

skipwhite:	cmp	BYTE PTR ES:[di],' '            ;is it a space?
		je	nextchar
		cmp	BYTE PTR ES:[di],9		;is it a tab?
		je	nextchar
		cmp	BYTE PTR ES:[di],0		;if null, then no args
		jne	@F
		jmp	argsdone
@@:		cmp	BYTE PTR ES:[di],0Ah		;if LF, then no args
		jne	@F
		jmp	argsdone
@@:		cmp	BYTE PTR ES:[di],0Dh		;if CR, then no args
		jne	@F
		jmp	argsdone

nextchar:	inc	di			;otherwise, look at next char
		jmp	skipwhite

;if we're here, we've found an argument. process it.

@@:

verbosechk:

		mov	al,BYTE PTR ES:[di]
		cmp	al, '9'             ;>9
		ja	@F

		cmp	al, '2'             ;<2
		jb	@F

		sub	al,'0'
		mov	BrdNum,al
		ADD	AL, '0'


		push	si
		lea	si,xDriverName
		mov	cx,10h
SearchBnum3:
		inc	si
		cmp	BYTE PTR [si],'$'
		je	@F
		loop	SearchBnum3
@@:
		MOV	BYTE PTR [si], AL
		inc	si
		MOV	BYTE PTR [si], '$'   ;end signature
		MOV	BYTE PTR [si+1], 0   ;end signature

		pop	si




		jmp	displayF

@@:
		cmp	BYTE PTR ES:[di], 'D'
		je	displayF
		cmp	BYTE PTR ES:[di], 'd'
		je	displayF
		jmp	badarg
displayF:	inc	di
		jmp	skipwhite

;bad argument
badarg: 	mov	ax,BAD_ARG
		jmp	parseend

argsdone:
		mov	ax,0

parseend:	pop	di
		pop	bx
		pop	es
		ret
A_ENDP		ParseArgs



COMMENT ^

----------------------------------------------------------------------------
$Name: GetGDTs
----------------------------------------------------------------------------
$Description:
This procedure allocates the GDTs which are used by the program.
$

$Method:
$
^

L_PROC		GetGDTs
;get board memory in a segment
IFDEF		DOS			      ;DOS
		NOP
ELSE					      ;OS/2
		   ; Allocate Global Selector

		cli				; Protect PhysToVirt
		push	ds
		pop	es			; ES = DS
		push	cs
		pop	ds
		mov	si,offset CGROUP:cs_ds	; DS:SI = address of cs_ds
		mov	dl,DevHlp_VirtToPhys	; get AX:BX = physical cs_ds
		call	es:Device_Help
		push	es
		pop	ds			; restore DS
		mov	cx,SIZE cs_ds		; only one word writable
		mov	dh,1			; return in ES:DI
		mov	dl,DevHlp_PhysToVirt	; writable selector please
		call	Device_Help
		mov	ax, DriverHead.SProtDS	;get protected mode DS
		mov	es:[di],ax	 ; save it in CS:cs_ds
		mov	dl,DevHlp_UnPhysToVirt	; release selector to OS/2
		call	Device_Help

		mov	cx,1
		push	ds
		pop	es
		mov	dl,DevHlp_AllocGDTSel
		mov	di,offset DGROUP:segTX
		call	Device_Help
		mov	di,offset DGROUP:segRX
		call	Device_Help
		sti				; UnProtect
ENDIF
		mov	ax, SUCCESS
		ret
L_ENDP		GetGDTs





;------------------------------------------------------------------------------
; Procedure Name : String compare
; Destination	 : ES:DI
; Source	 : DGROUP:SI
; Return value	 : SUCESS - string is equal
;		   CompareFail - string is not equal
;------------------------------------------------------------------------------

CompareFail	EQU	  1

L_PROC		StringCompare
Next_Char:	CMP	  BYTE PTR ES:[DI], 0	; 0 represents end of string
		JZ	  StringOver	  ; Destination string is in the end
		MOV	  AL, BYTE PTR ES:[DI]	; get destination char
		CMP	  AL, 61H	  ; capital character ? 'a'
		JB	  @F
		CMP	  AL, 7AH	  ; 'z'
		JA	  @F
		SUB	  AL, 20H	  ; make char = capital
@@:		CMP	  AL, BYTE PTR DGROUP:[SI]  ; compare
		JNZ	  Not_Equal	  ; string is not equal
		INC	  SI		  ; go to next char
		INC	  DI		  ; go to next char
		JMP	  Next_Char

StringOver:	CMP	  BYTE PTR DGROUP:[SI], 0
		; check source string is over also ?
		JZ	  CompareOK	  ; string is equal
Not_Equal:	MOV	  AX, CompareFail ; string is not equal
		RET

CompareOK:	MOV	  AX, SUCCESS
		RET

L_ENDP		StringCompare


COMMENT ^

----------------------------------------------------------------------------
$Name: Register - register our module with the Protocol Manager$
----------------------------------------------------------------------------
$Description:
This procedure calls RegisterModule to register the driver with the
protocol manager.
$

$Method:
$
^

L_PROC		Register
		mov	protreq.pm_opcode,2	   ;opcode for call
		mov	ax, ds			   ;DriverHead.SProtDS
		mov	protreq.pm_ptr1._seg,ax    ;ptr to common char.
		mov	protreq.pm_ptr1._off, OFFSET DGROUP:CommChar
						   ;offset of CommChar
		mov	protreq.pm_ptr2._seg,0	   ;ptr to binding list
		mov	protreq.pm_ptr2._off,0

IFDEF		DOS				   ;DOS

		mov	ah,3dh			   ;open the device
		mov	al,40h			   ;Deny None, Read Only
		mov	dx, OFFSET DGROUP:protdev  ;device name
		int	21h			   ;return file handle
		mov	filehandle,ax
	     ;get the file handle
		jnc	@F			   ;check for error
		mov	ax,PROTMGR_ERR		   ;error - with carry
		ret

@@:		mov	ah,44h			   ;IOCTL req
		mov	al,02h			   ;device input
		mov	dx,OFFSET DGROUP:protreq   ;pointer to reqblock
		mov	cx,14			   ;size of ReqBlock
		mov	bx,filehandle
		int	21h			   ;call DOS
		mov	ax,protreq.pm_status	   ;get status
		xor	ah,ah			   ;clear ah
ELSE						   ;OS/2
;open the protocol manager
		push	ds
		pushc	<OFFSET DGROUP:protdev>
		push	ds
		pushc	<OFFSET DGROUP:filehandle>
		push	ds
		pushc	<OFFSET DGROUP:action>
		pushc	<WORD PTR 0>
		pushc	<WORD PTR 0>
		pushc	<WORD PTR READONLY_FILE>
		pushc	<WORD PTR (NOTEXIST_FAIL OR EXIST_OPEN)>
		pushc	<WORD PTR (DENY_NONE OR READ_ONLY)>
		pushc	<WORD PTR 0>
		pushc	<WORD PTR 0>
		call	DOSOPEN

		cmp	ax,0		;open ok?
		je	@F
		mov	ax,PROTMGR_ERR
		ret

@@:		pushc	0			;pointer to data area
		pushc	0
		push	ds
		pushc	<OFFSET DGROUP:protreq>
		pushc	PMGR_IOCTL_FUNC
		pushc	PMGR_CATEGORY
		push	filehandle
		call	DOSDEVIOCTL
ENDIF

IFDEF		DOS				;DOS
		push	ax
		mov	ah,3eh			;open the device
		mov	bx,DGROUP:filehandle
		int	21h			;return file handle
		pop	ax

ENDIF
IFNDEF		 DOS				;DOS
		push	ax
		pushc	<OFFSET DGROUP:filehandle>
		call	DOSCLOSE
		pop	ax

ENDIF
		cmp	ax, SUCCESS
		je	@F
		mov	ax,REG_ERR
@@:		ret
L_ENDP		Register

COMMENT ^

----------------------------------------------------------------------------
$Name: PrintParamMsg - Print the parameter message$
----------------------------------------------------------------------------
$Description:
This routine prints the parameter message given if the driver is in verbose
mode.  It fills in the IObase, memory size, and interrupt level fields
of the message.
$

$Method:
$
^

L_PROC	PrintParamMsg
		mov	ax,CS:IOBase		   ;fill in memory base
		mov	si,offset DGROUP:IOBasestr ;address of string
		add	si,2			   ;end of string
		mov	bx,16			   ;hex representation
		call	IntToString		   ;convert it

		mov	ax,IRQ			   ;fill in Int. Level
		mov	si,offset DGROUP:Intstr    ;address of string
		add	si,1			   ;end of string
		mov	bx,10			   ;hex representation
		call	IntToString		   ;convert it

;print the string
		pushc	<WORD PTR STDOUT>	   ;print message
		pushc	<WORD PTR paramlen>
		push	ds
		pushc	<OFFSET DGROUP:parammess>
		call	DOSPUTMESSAGE
		ret

L_ENDP		PrintParamMsg



COMMENT ^

----------------------------------------------------------------------------
$Name: Init - Main driver initialization routine
----------------------------------------------------------------------------
$Description:
This is the main initialization procedure for the driver. It does the
following:
	1. Get the address of the Device_help routine and put it in our CS
	2. Parse command line arguments
	3. Initialize the modules of the driver.
	4. Figure out the hardware parameters of the board.
	5. Allocate any needed GDTs and map board memory
	6. Register with the protocol manager.
	7. Print out messages on the monitor.
$

$Method:
$
^

A_PROC		Init
TmpDevHelp	EQU	<DWORD PTR [bp-4]>
TmpDevHelpSeg	EQU	<WORD PTR [bp-2]>
TmpDevHelpOff	EQU	<WORD PTR [bp-4]>




;save request packet on stack
	push	bp
	sub	sp, size LOCALDATA
	mov	bp,sp
	sub	sp,4
	mov	[bp].LD_PTRSAVE._OFF,bx ;Far pointer of request header
	mov	[bp].LD_PTRSAVE._SEG,es
;get a segment/selector for our CS so we can store DevHlp into it.

IFNDEF	DOS			       ;OS/2
;get the devhlp address and save it in a temp. variable
	mov	ax, es:[bx].initdevhlp._off
	mov	TmpDevHelpOff,ax
	mov	ax, es:[bx].initdevhlp._seg
	mov	TmpDevHelpSeg,ax

	mov	ax, TmpDevHelpOff	;put devhlp in our CS
	mov	Device_Help._off,ax
	mov	ax,TmpDevHelpSeg
	mov	Device_Help._seg,ax

ENDIF
       or      ServStat.ms_status._lo, MS_OK   ;hardware OK
;============================== PARSE ARGUMENT ================================
;parse the arguments on the device line in config.os2
	call	ParseArgs
	cmp	ax,0
	je	@F
	jmp	init_err
@@:
;------ InitRequest
	call	Init_Request		;Initialize Request module
	cmp	ax,0			;ok?
	je	@F			;yes
	mov	ax,INTERNAL_ERR
	jmp	init_err		;no. error

@@:

	call	FindBoardName		;find which card adapter name
					;RTSND1 RTSND2 .....
	call	Init_Tables		;Initialize Tables module and check
					;how many bords are there
	cmp	ax,0			;ok?
	je	@F			;yes
	mov	ax,INTERNAL_ERR
	jmp	init_err		;no. error

;------ InitTransmit
@@:
	call	Init_Transmit		;Initialize Transmit timer
	cmp	ax,0			;ok?
	je	@F			;yes
	mov	ax,INTERNAL_ERR
	jmp	init_err		;no. error
;================================ PARSE IMAGE =================================
;parse the image which is read by protocol manager
@@:

	call	ParseImageFdDev 	;Parse Image File and Find Driver Name
					;Direct Scan IOBASE and IRQ
	cmp	ax,0
	je	@F
	jmp	init_err

;================================= GetGDTs ====================================
;get selectors used in the driver. This call trashes the ES selector used
;for the board segment
@@:
	push	es
	push	bx
	call	GetGDTs 		;
	pop	bx
	pop	es
	cmp	ax,0
	je	@F
	jmp	init_err2

;================================ Register ====================================
;register our module with the protocol manager if we are not in standalone
;mode
@@:

	call	Register		;no. register with ProtMgr
	cmp	ax,0
	je	skipreg
	mov	ax, INT_ERR
	jmp	init_err2
skipreg:

;================================ NIC H/W init ================================
	call	init_test		;initial Register , test Rx , Tx , loopback mode
	cmp	ax,0			;ResetNIC
	je	@F
	jmp	init_err2

@@:


IFNDEF	DOS				;OS/2
	mov	dl,DEVHLP_UNPHYSTOVIRT
	call	[Device_Help]
ENDIF

;success. Output message.

	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR goodlen>
	push	ds
	pushc	<OFFSET DGROUP:goodmess>
	call	DOSPUTMESSAGE

	cmp	verbose,1		;print out parameters?
	jne	@F			;no
	call	PrintParamMsg		;yes
;set up new memory bounds
@@:	 les	 bx, [bp].LD_PTRSAVE	;get back request header

IFDEF	DOS					;DOS
	mov	ES:[bx].InitEcode, OFFSET DGROUP:CodeSegEnd
		       ;return end of code segment
	mov	ES:[bx].InitEdata,cs
		       ;in dos, this is seg. of free mem
ELSE					       ;OS/2
	mov	ES: [bx].InitEcode, OFFSET CodeSegEnd	;return end of code
	mov	ES:[bx].InitEdata, OFFSET DataSegEnd	;and end of data
ENDIF
	mov	ES:[bx].PktStatus, STDON;return status
	mov	ES:[bx].InitcUnit,0
	mov	ES:[bx].InitpBPB._lo,0
	mov	ES:[bx].InitpBPB._hi,0
	jmp	CleanUp

;we enter here if the error occurred after we obtained the timer interrupt.

init_err2:
	push	ax			;save error code
	call	RestoreTimer		;restore timer interrupt
	pop	ax

;deal with an error
init_err:

IFNDEF	DOS				;DOS
	mov	dl,DEVHLP_UNPHYSTOVIRT
	call	[Device_Help]
ENDIF					;OS/2

	push	ax				;save error code

	pushc	<WORD PTR STDOUT>		;output error message
	pushc	<WORD PTR errlen>
	push	ds
	pushc	<OFFSET DGROUP:errmess>
	call	DOSPUTMESSAGE

	pop	bx				;get back error number
	cmp	bx,INTERNAL_ERR 		;make sure its not too big
	jbe	@F
	mov	bx,INTERNAL_ERR
@@:	sub	bx,1
	shl	bx,1				;index into error description table
	shl	bx,1
	pushc	<WORD PTR STDOUT>		;output error description
	push	DGROUP:errdescr[bx]+2		;description length
	push	ds
	push	DGROUP:errdescr[bx]		;desription message
	call	DOSPUTMESSAGE

	cmp	verbose,1			;print out parameters?
	jne	@F				;no
	call	PrintParamMsg			;yes

IFDEF	DOS				  ;DOS
@@:	pushc	<WORD PTR STDOUT> ;print out "Hit any key.." message
	pushc	<WORD PTR cntlen>
	push	ds
	pushc	<OFFSET DGROUP:cntmess>
	call	DOSPUTMESSAGE
	mov	ah,0CH		      ;clear keyboard buffer
	mov	al,8		      ;and get a char with out echo
	int	21h		      ;call DOS

	mov	ah,2		      ;output CR
	mov	dl,0dh
	int	21h
	mov	ah,2		      ;output LF
	mov	dl,0ah
	int	21h
	mov	ah,2		      ;output LF
	mov	dl,0ah
	int	21h
ENDIF

@@:	les	bx, [bp].LD_PTRSAVE	;get back request header
IFDEF	DOS					 ;DOS
	mov	ES: [bx].InitEcode, OFFSET DGROUP:CodeSegEnd
			;return end of code segment
	mov	ES:[bx].InitEdata,cs
			;in dos, this is seg. of free mem
			;In dos, this is address of DevHdr
ELSE						 ;OS/2
	mov	ES: [bx].InitEcode, OFFSET CodeSegEnd
	mov	ES:[bx].InitEdata, OFFSET DataSegEnd
ENDIF
	mov	ES:[bx].PktStatus, STDON+ERROR_I24_BAD_COMMAND ;ERROR_I24_GEN_FAILURE	 ;return status
	mov	ES:[bx].InitcUnit,0
	mov	ES:[bx].InitpBPB._lo,0
	mov	ES:[bx].InitpBPB._hi,0


CleanUp:
	add	sp,4
	add	sp, SIZE LOCALDATA
	pop	bp
	ret

A_ENDP		Init

;-----------------------------------------------
;Write module name into CommChar
;Destination: DS:DI
;Source     : ES:SI
;-----------------------------------------------

L_PROC	CpyMdNam2CmCh
Next_Char1:

	CMP	BYTE PTR ES:[SI], 0   ; 0 represents end
	JZ	StringOver1	 ; Source
	MOV	AL, BYTE PTR ES:[SI]  ;
	MOV	DS:[DI], AL
	INC	DI
	INC	SI
	dec	cx
	jz	StringOver1
	JMP	Next_Char1
StringOver1:
	MOV	BYTE PTR DS:[DI], 0
	ret
L_ENDP		CpyMdNam2CmCh


;----------------------------------------------------------------------------
;Name: ParseImageFdDev - Parse Image File and Find Driver Name
;----------------------------------------------------------------------------

L_PROC		ParseImageFdDev
.386P
	PUSH	ES			   ;reserve ES and BX
	PUSH	BX
	 ; 1 represent GetProtocolManagerInfo
	mov	protreq.pm_opcode,1	   ;opcode for call

IFDEF	DOS				   ;DOS
	mov	ah,3dh			   ;open the device
	mov	al,40h			   ;Deny None, Read Only
	mov	dx, OFFSET DGROUP:protdev  ;device name
	int	21h			   ;return file handle
	mov	filehandle,ax		   ;get the file handle
	jnc	@F			   ;check for error
	POP	BX			   ;recover ES and BX
	POP	ES
	mov	ax,PROTMGR_ERR		   ;error - with carry
	ret


@@:	mov	ah,44h			   ;IOCTL req
	mov	al,02h			   ;device input
	mov	dx,OFFSET DGROUP:protreq   ;pointer to reqblock
	mov	cx,14			   ;size of ReqBlock
	mov	bx,filehandle
	int	21h			   ;call DOS
ELSE					    ;OS/2
;open the protocol manager
	push	ds
	pushc	<OFFSET DGROUP:protdev>
	push	ds
	pushc	<OFFSET DGROUP:filehandle>
	push	ds
	pushc	<OFFSET DGROUP:action>
	pushc	<WORD PTR 0>
	pushc	<WORD PTR 0>
	pushc	<WORD PTR READONLY_FILE>
	pushc	<WORD PTR (NOTEXIST_FAIL OR EXIST_OPEN)>
	pushc	<WORD PTR (DENY_NONE OR READ_ONLY)>
	pushc	<WORD PTR 0>
	pushc	<WORD PTR 0>
	call	DOSOPEN

	cmp	ax,0		;open ok?
	je	@F
	POP	BX			   ;recover ES and BX
	POP	ES
	mov	ax,PROTMGR_ERR
	ret
@@:
	pushc	0			;pointer to data area
	pushc	0
	push	ds
	pushc	<OFFSET DGROUP:protreq>
	pushc	PMGR_IOCTL_FUNC
	pushc	PMGR_CATEGORY
	push	filehandle
	call	DOSDEVIOCTL
ENDIF
	mov	ax,protreq.pm_status	   ;get status
	xor	ah,ah			   ;clear ah
	cmp	ax, SUCCESS
	je	@F
	POP	BX			   ;recover ES and BX
	POP	ES
IFDEF	DOS				   ;DOS
	mov	ah,3eh			   ;open the device
	mov	bx,DGROUP:filehandle
	int	21h			   ;return file handle
ENDIF
IFNDEF	DOS				   ;DOS
	push	ax
	pushc	<OFFSET DGROUP:filehandle>
	call	DOSCLOSE
	pop	ax

ENDIF
	mov	ax,REG_ERR
	ret


@@:
	MOV	Si, OFFSET DGroup:DriverName; point to offset of Dr
	MOV	DI, OFFSET DGroup:YDriverName; point to offset of Dr
	mov	cx,10h
MovDriveNam:
	mov	al, byte ptr DGroup:[si]
	mov	byte ptr DGroup:[di],al
	cmp	byte ptr DGroup:[si],'$'
	je	MovDriveNam_1
	inc	si
	inc	di
	loop	MovDriveNam
MovDriveNam_1:
	inc	di
	mov	byte ptr [di],0

	MOV	AX, ProtReq.pm_ptr1._SEG   ;get image pointer
	MOV	MemoryImagePtr._HI, AX
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX
	MOV	AX, ProtReq.pm_ptr1._OFF
	MOV	MemoryImagePtr._LO, AX
	MOV	BX, AX

	ADD	BX, mc_keyword		   ;get keyword pointer
	MOV	MemoryImagePtr2._LO, BX
; Now, ES:BX is the image pointer

Next_Module:
	ADD	BX, kw_keyword		   ; driver name in image
;Compare driver name with RTL8139
	MOV	DI, BX


NextKeyWord:
;11/10/95 in win95 application
	MOV	SI, OFFSET DGroup:DriverString; point to offset of Dr

	push	di
	CALL	StringCompare		   ; compare driver name
	pop	di
	CMP	AX, SUCCESS
	jnz	not_drivername

	MOV	SI, OFFSET DGroup:YDriverName; point to offset of Dr
	SUB	DI, kw_keyword
	ADD	DI, kw_param		   ;goto paramter pointer
	ADD	DI, pm_num		   ;get parameter
	push	si

	CALL	StringCompare		   ; compare driver name
	CMP	AX, SUCCESS

	pop	si
	jz	SetModuleName
not_drivername:
	MOV	di, MemoryImagePtr2._LO
	MOV	ax, MemoryImagePtr2._HI
	mov	es,ax
	ADD	di, kw_next
	MOV	AX, ES:[di]._SEG	   ;get next module pointer
	MOV	CX, ES:[di]._OFF	   ;get next module pointer
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX			   ;update ES
	MOV	MemoryImagePtr2._LO, CX
	MOV	di, CX			   ;update BX
	ADD	di, kw_keyword		   ; driver name in image
	OR	AX, CX			   ;check null pointer
	JZ	NOT_STRING
	jmp	NextKeyWord

SetModuleName:
	mov	DI, OFFSET DGROUP:CommChar  ;offset of CommChar
	ADD	DI, 12			    ;ptr to modulename in
					    ;CommChar
	MOV	AX, MemoryImagePtr._HI
	MOV	ES, AX
	MOV	SI, MemoryImagePtr._LO
	ADD	SI, MC_NAME
	CALL	CpyMdNam2CmCh
	JMP	FindModule

NOT_STRING:
	MOV	BX,MemoryImagePtr._LO
	MOV	ax, MemoryImagePtr._HI
	mov	es,ax
	ADD	BX, mc_next
	MOV	AX, ES:[BX]._SEG	   ;get next module pointer
	MOV	CX, ES:[BX]._OFF	   ;get next module pointer
	MOV	MemoryImagePtr._HI, AX
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX			   ;update ES
	MOV	MemoryImagePtr._LO, CX
	MOV	BX, CX			   ;update BX
	ADD	BX, mc_keyword		   ;get keyword pointer
	MOV	MemoryImagePtr2._LO, BX
;=======
	INC	DL
	OR	AX, CX			   ;check null pointer
	JZ	@F
	JMP	Next_Module

@@:
IFDEF	DOS				   ;DOS
	mov	ah,3eh			   ;open the device
	mov	bx,DGROUP:filehandle
	int	21h			   ;return file handle
ENDIF
IFNDEF	 DOS				    ;DOS
	push	ax
	pushc	<OFFSET DGROUP:filehandle>
	call	DOSCLOSE
	pop	ax

ENDIF
	MOV	AX, BRD_NOT_FOUND
	POP	BX
	POP	ES
	RET
FindModule:

	MOV	AX, MemoryImagePtr._HI	   ;pointer of find module
	MOV	ES, AX
	MOV	MemoryImagePtr2._HI, AX
	MOV	AX, MemoryImagePtr._LO
	MOV	BX, AX
	ADD	BX, mc_keyword		   ;get keyword pointer
	MOV	MemoryImagePtr2._LO, BX

Next_KeyWord:
	ADD	BX, kw_keyword		   ;goto keyword pointer
	;prepare dest. & source string address for compare
	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageMediumString

	;Now compare Auto string

	CALL	StringCompare

	JNZ	Next_Netaddr
	SUB	BX, kw_keyword
	ADD	BX, kw_param		   ;goto paramter pointer
	ADD	BX, pm_type		   ;get parameter
	ADD	BX, pm_len		   ;
	ADD	BX, 2			   ;


	mov	al ,byte ptr es:[BX]   ;read medium value
	cmp	al ,30h 	       ;'0'
	jb	@F
	cmp	al ,34h 	       ;'4'
	jae	@F

	mov	Medium,al
	mov	Force_Flag,1		   ;True

					   ;dos keyword is
					   ; 0:Auto
					   ; 1:10Half
					   ; 2:10Full
					   ; 3:100Half
					   ; 4:100Full



	jmp	Next_Netaddr
@@:
	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageAutoString

	;Now compare _Auto string

	CALL	StringCompare
	JNZ	Next_String_100Full
	mov	Medium,0
	mov	Force_Flag,1		   ;True
	jmp	Next_Netaddr
Next_String_100Full:

	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:Image100FullString

	;Now compare _100Full string

	CALL	StringCompare
	JNZ	Next_String_100Half
	mov	Medium,4
	mov	Force_Flag,1		   ;True
	jmp	Next_Netaddr

Next_String_100Half:

	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:Image100HalfString

	;Now compare _100Half string

	CALL	StringCompare
	JNZ	Next_String_10Full
	mov	Medium,3
	mov	Force_Flag,1		   ;True
	jmp	Next_Netaddr

Next_String_10Full:

	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:Image10FullString

	;Now compare _10Full string

	CALL	StringCompare
	JNZ	Next_String_10Half
	mov	Medium,2
	mov	Force_Flag,1		   ;True
	jmp	Next_Netaddr

Next_String_10Half:

	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:Image10HalfString

	;Now compare _10Half string

	CALL	StringCompare
	JNZ	Next_Netaddr
	mov	Medium,1
	mov	Force_Flag,1		   ;True
	jmp	Next_Netaddr




					   ;dos keyword is
					   ; 0:Auto
					   ; 1:10Half
					   ; 2:10Full
					   ; 3:100Half
					   ; 4:100Full

Next_Netaddr:

	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageNETString
	;Now compare NetAddress string

	CALL	StringCompare
	JZ	NEXT_Find_Para
	JMP	Next_KeyWord1		  ;compare next string
NEXT_Find_Para:
	SUB	BX, kw_keyword
	ADD	BX, kw_param		   ;goto paramter pointer
	ADD	BX, pm_type		   ;get parameter
	MOV	AX, ES:[BX]		   ;get value

	or	ax, ax
      ; jz	ModuleOver
	jz	UpdatePtr		   ;compare next string


	ADD	BX, pm_len		   ;
	MOV	AX, ES:[BX]		   ;
	cmp	ax, 13			   ; Compare length
      ; jb	ModuleOver		   ;
	jb	UpdatePtr		   ;compare next string

	cmp	ax, 80			   ; Compare length
	jb	IDLenOK1		   ;
	mov	ax, 79			   ;
IDLenOK1:
	mov	cx, ax			   ;
	add	bx, 2			   ; Skip length
	push	bx			   ;
FindKey1:
	cmp	byte ptr es:[bx],'@'       ; Find  '@'
	je	StartBufferID1		   ;
	inc	bx			   ;
	dec	cx			   ;
	jnz	FindKey1		   ;

	mov	cx,ax			   ; Can not find '@'
	pop	bx			   ; go back to first char

	jmp	BufferID1		   ;
StartBufferID1:
	pop	ax			   ;
	inc	bx			   ; point to first ID byte
	dec	cx			   ;
BufferID1:
	shr	cx,1
	shr	cx,1
	mov	di, offset NetAddr	   ; Put ID string into buffer
BufferNextID1:					   ;
	mov	eax, dword ptr ES:[bx]	   ;
	mov	dword ptr [di], eax	   ;
	add	bx,4
	add	di,5			   ;
	dec	cx			   ;
	jnz	BufferNextID1		   ;

	mov	al, 0			   ; Append null char
	mov	byte ptr [di], al	   ;
	mov	Netflag, 1		   ;
					   ;
	mov	di, offset NetAddr	   ; Put ID string into buffer
	mov	si, offset NetAddress	   ; Put ID string into buffer
	mov	cx,0
   Convert_ASCII:
	mov	bx, offset ID_USER
	push	bx
	push	es
	push	ds
	pop	es
	push	di
	call	HexStringToInt
	pop	di
	pop	es
	pop	bx
	xchg	ah,al
	mov	byte ptr ds:[si],al
	add	si,2
	mov	byte ptr ds:[si],ah
	add	si,2
	add	di,5
	add	bx,cx
	add	bx,cx
	mov	[bx],ax
	inc	cx
	cmp	cx,3
	jbe	Convert_ASCII
	JMP	UpdatePtr		   ;compare next string
      ; JMP	ModuleOver		   ;

Next_KeyWord1:


	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageTxFiFoString
	;*** compare TxFiFo string ***
	CALL	StringCompare
	JNZ	Next_KeyWord2

	SUB	BX, kw_keyword
	ADD	BX, kw_param		   ;goto paramter pointer
	ADD	BX, pm_type		   ;get parameter
	;Slot value get in protocol.ini paramter
	;SLOT(a word) = Bus Number(hi byte) Device Number (Low byte)
	ADD	BX, pm_len		   ;
	ADD	BX,2			   ;skip length
	xor	eax,eax

	mov	al,byte ptr es:[BX]
	xor	ah,ah

	shl	eax,16
	mov	RESV1,eax

	JMP	UpdatePtr		   ;compare next string



Next_KeyWord2:


	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageIDString
	;*** compare ETHETID string ***
	CALL	StringCompare
	JZ	FillIDbuffer
					  ;compare next string
	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageBusString

	;*** compare Bus string ***

	CALL	StringCompare
	JNZ	Next_String		    ;compare next string

	SUB	BX, kw_keyword
	ADD	BX, kw_param		   ;goto paramter pointer
	ADD	BX, pm_type		   ;get parameter
	mov	SlotFlag,1
	;Slot value get in protocol.ini paramter
	;SLOT(a word) = Bus Number(hi byte) Device Number (Low byte)
	ADD	BX, pm_len		   ;
	ADD	BX,2			   ;skip length
	mov	al,byte ptr es:[BX]
	mov	byte ptr ds:[BUSNO],al
	JMP	UpdatePtr		   ;compare next string
Next_string:

	MOV	DI, BX			   ;ES:DI
	MOV	SI, OFFSET DGROUP:ImageDeviceString

	;*** compare Bus string ***

	CALL	StringCompare
	JNZ	UpdatePtr		   ;compare next string
	SUB	BX, kw_keyword
	ADD	BX, kw_param		   ;goto paramter pointer
	ADD	BX, pm_type		   ;get parameter
	mov	SlotFlag,1
	;Slot value get in protocol.ini paramter
	;SLOT(a word) = Bus Number(hi byte) Device Number (Low byte)

	ADD	BX, pm_len		   ;
	ADD	BX,2			   ;skip length
	mov	al,byte ptr es:[BX]
	mov	byte ptr ds:[BUSNO+1],al

	jmp	ModuleOver

Next_string1:
	jmp	NoSlotSpecified

FillIDbuffer:
	SUB	BX, kw_keyword
	ADD	BX, kw_param		   ;goto paramter pointer
	ADD	BX, pm_type		   ;get parameter
	MOV	AX, ES:[BX]		   ;get value

	or	ax, ax
	jz	ModuleOver


	ADD	BX, pm_len		   ;
	MOV	AX, ES:[BX]		   ;
	cmp	ax, 13			   ; Compare length
	jb	ModuleOver		   ;


					   ;
	cmp	ax, 80			   ; Compare length
	jb	IDLenOK 		   ;
	mov	ax, 79			   ;
IDLenOK:
	mov	cx, ax			   ;
	add	bx, 2			   ; Skip length
	push	bx			   ;
FindKey:
	cmp	byte ptr es:[bx],'@'       ; Find  '@'
	je	StartBufferID		   ;
	inc	bx			   ;
	dec	cx			   ;
	jnz	FindKey 		   ;

	mov	cx,ax			   ; Can not find '@'
	pop	bx			   ; go back to first char

;**************************************************
;5.22.98 skip @ format
		inc	bx
		dec	cx

;**************************************************

	jmp	BufferID_A		 ;
StartBufferID:
	pop	ax			   ;
	inc	bx			   ; point to first ID byte
	dec	cx			   ;
BufferID_A:
	mov	di, offset ID_Buffer	   ; Put ID string into buffer
BufferNextID:					   ;
	mov	al, byte ptr ES:[bx]	   ;
	mov	byte ptr [di], al	   ;
	inc	bx			   ;
	inc	di			   ;
	dec	cx			   ;
	jnz	BufferNextID		   ;

	mov	al, 0			   ; Append null char
	mov	byte ptr [di], al	   ;
	mov	IDflag, 1		   ;

	jmp	ModuleOver

UpdatePtr:
	MOV	BX, MemoryImagePtr2._LO
	ADD	BX, kw_next
	MOV	AX, ES:[BX]._SEG	   ;get next module pointer
	MOV	CX, ES:[BX]._OFF	   ;get next module pointer
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX			   ;update ES
	MOV	MemoryImagePtr2._LO, CX
	MOV	BX, CX			   ;update BX
	OR	AX, CX			   ;check null pointer
	JZ	KeyWordOver
	JMP	Next_KeyWord
;
;******************************* } Jasper 09/16/94 **************************
;

.286P
KeyWordOver:
ModuleOver:
IFDEF		DOS				   ;DOS
	mov	ah,3eh			   ;open the device
	mov	bx,DGROUP:filehandle
	int	21h			   ;return file handle
ENDIF
IFNDEF		 DOS				    ;DOS
	push	ax
	pushc	<OFFSET DGROUP:filehandle>
	call	DOSCLOSE
	pop	ax
ENDIF

IFDEF	DOS

;	Is PCI system ?
	mov	ah, PCI_FUNCTION_ID
	mov	al, PCI_BIOS_PRESENT
	int	1Ah
	pushf
	pop	dx
	test	dx, 0001h
	jz	PCI_system

	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR PCI_ERRLen>
	push	ds
	pushc	<OFFSET DGROUP:PCI_ERR>
	call	DOSPUTMESSAGE
	jmp	Error8139

PCI_system:
	mov	 NumOf8139,0			 ; Increment adapter count
       ;pushc	<WORD PTR STDOUT>
       ;pushc	<WORD PTR LoadingDosMsgLen>
       ;push	ds
       ;pushc	<OFFSET DGROUP:LoadingDosMsg>
       ;call	DOSPUTMESSAGE
	mov	si,0h

FINDOURDEVICE:
;	Find our device
	mov	ah, PCI_FUNCTION_ID
	mov	al, FIND_PCI_DEVICE
	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID		; Vendor ID
	int	1Ah
	cmp	ah,0h				;succesful
	jne	NOT_OUR_DEVICE

	;if it is our 8139 save it config
	mov	[BUS_DEV_NUM],bx		;for LBtest used


	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,10h
	int	1Ah

	mov	di, Offset IOBuffer		;
	add	di, NumOf8139			; Record IO base in buffer
	add	di, NumOf8139			; Record IO base in buffer
	and	cl,11111110b
	mov	[di], cx			;


	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,2Eh
	int	1Ah
	mov	di, Offset Sub_Vender_ID	;
	add	di, NumOf8139			; Record Sub_Vendor in buffer
	mov	[di], cl			;


	mov	ah, PCI_FUNCTION_ID
	mov	al, READ_CONFIG_BYTE
	mov	di,3ch
	int	1Ah

	mov	di, Offset IRQBuffer		; Record  IRQ in buffer
	add	di, NumOf8139			;
	mov	[di], cl			;
	inc	NumOf8139			; Increment adapter count

;write bus master enable configuration space offset 4 bit 2=1

	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_BYTE
	mov	di,04h
	int	1Ah
	test	cx,04				;or bus master bit
	jnz	@F
	or	cx,04
	mov	ah,PCI_FUNCTION_ID
	mov	al,WRITE_CONFIG_BYTE
	mov	di,04h
	int	1Ah

@@:

NOT_OUR_DEVICE:
	inc	si
	cmp	si,11h			;there are 16 possible device in pci
	jne	FINDOURDEVICE

ELSE						; 12/20/94

;============= Begin OS/2 Seach 8139 ==========
;97.1.22
	mov	ax, (PCI_BIOS_INT_ADDR SHR 16) ; high-order part of physical addr.
	mov	bx, 0			; start of that segment
	mov	cx, 0			; map full 64KB
	mov	dh, UVIRT_RE		; make it executable-readable
	mov	dl, DEVHLP_PHYSTOUVIRT	; function to get virtual address
	call	ds:[device_HELP]	; get it
	jnc	PCI_System		; branch on error

	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR PCI_ERRLen>
	push	ds
	pushc	<OFFSET DGROUP:PCI_ERR>
	call	DOSPUTMESSAGE
	jmp	Error8139

PCI_system:

	add	 bx, (PCI_BIOS_INT_ADDR AND 0FFFFh) ; low-order part of phys addr
	mov	 BIOSServiceEntry._off, bx  ; save entry point offset
	mov	 BIOSServiceEntry._seg, es  ; save entry point segment


	mov	 NumOf8139,0		; Increment adapter count
       ;pushc	<WORD PTR STDOUT>
       ;pushc	<WORD PTR LoadingOS2MsgLen>
       ;push	ds
       ;pushc	<OFFSET DGROUP:LoadingOS2Msg>
       ;call	DOSPUTMESSAGE
	mov	si,0h

FINDOURDEVICE:
	;Find our device
	mov	ah, PCI_FUNCTION_ID
	mov	al, FIND_PCI_DEVICE
	mov	cx, RTL_PCI_ID		; device ID
	mov	dx, RTL_VENDOR_ID	; Vendor ID

	pushf
	call ds:[BIOSServiceEntry]

	cmp	ah,0h			;succesful
	jne	NOT_OUR_DEVICE
	;if it is our 8139 save it config

	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,10h
	pushf
	call	ds:[BIOSServiceEntry]
	and	cl,11111110b

	mov	di, Offset IOBuffer	;
	add	di, NumOf8139		; Record IO base in buffer
	add	di, NumOf8139		; Record IO base in buffer
	mov	[di], cx		;

	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,2Eh
	pushf
	call ds:[BIOSServiceEntry]
	mov	di, Offset Sub_Vender_ID	;
	add	di, NumOf8139			; Record Sub_Vendor in buffer
	mov	[di], cl			;

	mov	ah, PCI_FUNCTION_ID
	mov	al, READ_CONFIG_BYTE
	mov	di,3ch
	pushf
	call ds:[BIOSServiceEntry]

	mov	di, Offset IRQBuffer	; Record  IRQ in buffer
	add	di, NumOf8139		;
	mov	[di], cl		;
	inc	NumOf8139		; Increment adapter count

;write bus master enable configuration space offset 4 bit 2=1

	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_BYTE
	mov	di,04h
	pushf
	call ds:[BIOSServiceEntry]

	test	cx,04				;or bus master bit
	jnz	@F
	or	cx,04
	mov	ah,PCI_FUNCTION_ID
	mov	al,WRITE_CONFIG_BYTE
	mov	di,04h
	pushf
	call ds:[BIOSServiceEntry]
@@:


NOT_OUR_DEVICE:
	inc	si
	cmp	si,11h		;there are 16 possible device in pci
	je	@F
	jmp	FINDOURDEVICE

@@:
ENDIF
	cmp	NumOf8139,0			; Any RTL8029 ?
	ja	Get8139Config			;

	jmp	No8139				; No, error occur

Get8139Config:
	cmp	NumOf8139,1			; More than one RTL8029 ?
	jbe	One8139
	jmp	Which8139			;
One8139:

	mov	SlotFlag,0
	mov	al, IRQBuffer
	mov	ah, 0
	MOV	DGROUP:IRQ,AX			; report IRQ
	mov	ax, IOBuffer			; get IO base from buffer

IFDEF	DOS

	MOV	CS:IOBase,AX			; report IOBase

ELSE
	;************************ <OS/2> **************************
	; Subject : Change the value in Code segment
	;----------------------------------------------------------
	; NOTE : You can not modify the value in Code segment
	;	 directly under OS/2
	;----------------------------------------------------------
	PUSH	DS			;reserve ds
	PUSH	ES			;reserve es
	push	si
	push	dx
	push	cx
	PUSH	AX			;reserve AX

	push	ds			;mov cs into ds
	pop	es
	push	cs			;mov cs into ds
	pop	ds
	mov	si,0			;start of segment
	mov	DL, DEVHLP_VIRTTOPHYS	;convert CS to physical
	call	es:[Device_Help]	   ;phys addr in ax:bx

	mov	cx,0			;64K segment
	mov	dh,0			;result in DS
	mov	dl, DEVHLP_PHYSTOVIRT
	call	es:[Device_Help]

	push	ds			;use ES to write values
	pop	es			;so linker doesn't complain

	POP	AX			;recover AX
	MOV	ES:IOBase,AX			; report IOBase
	mov	ax,es
	pop	cx
	pop	dx
	pop	si
	POP	ES			;recover ES
	POP	DS			;recover DS

	;************************ <OS/2> **************************
ENDIF

	jmp	WeAreDone



; More than one RTL8139 found, get the right one
Which8139:


	cmp	NetFlag,1			;test Keyword "Netaddress"
	je	SearchID			;Yes

	cmp	IDFlag,1			; Is adapter ID specified?
	jne	NoIDSpecified			;    No , show error msg

	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR Multi8139IDMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:Multi8139IDMsg>
	call	DOSPUTMESSAGE
	call	ConvertID			; Conver to hexg.
	;jmp	 NoIDSpecified			 ;    Convert fail, show msg
	jc	NoIDSpecified			;    Convert fail, show msg
	jmp	test2
SearchID:
	mov	cl,byte ptr [BrdNum]
	dec	cl
	jmp	SearchIDDone

test2:
; Search RTL8139 adapter that match the ID specified in protocol.ini
	mov	cx,0				;
SearchIDLoop:					;
	mov	si,offset IOBuffer		;
	add	si,cx				;
	add	si,cx				;
	mov	di,offset Sub_Vender_ID 	;
	add	di,cx
	mov	al,byte ptr [di]
	mov	Sub_Vender_ID,al
	mov	dx,[si] 			;  Get I/O base
	call	CompareID			;  Compare ID
	jc	LOOP1
	jmp	SearchIDDone			;  Exit if successful
LOOP1:
	inc	cx				;
	cmp	cx, NumOf8139			;
	jb	SearchIDLoop			;  Try next if fail

NoIDSpecified:					;

	cmp	SlotFlag,1
	je	Show_Multi_Message
	jmp	NoSlotSpecified

Show_Multi_Message:

	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR Multi8139SlotMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:Multi8139SlotMsg>
	call	DOSPUTMESSAGE


IFDEF	DOS
	mov	BH,byte ptr ds:[BUSNO]	       ;Bus Number
	mov	BL,byte ptr ds:[BUSNO+1]       ;Device Number in upper 5 bit
	shl	BL,1
	shl	BL,1
	shl	BL,1
	and	bl,0f8h 		;Function Number in lower 3 bit

	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID			; Vendor ID
	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,02h
	int	1Ah
	cmp	cx,8139h
	je	Test_Device_Ok

	mov	SlotFlag,0			;Slot Function Fail
	jmp	Not_RTL8139_Adapter
Test_Device_Ok:

	mov	BH,byte ptr DS:[BUSNO]	    ;Bus Number
	mov	BL,byte ptr DS:[BUSNO+1]       ;Device Number in upper 5 bit
	shl	BL,1
	shl	BL,1
	shl	BL,1
	and	bl,0f8h 		;Function Number in lower 3 bit

	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID			; Vendor ID

	mov	ah, PCI_FUNCTION_ID
	mov	al, READ_CONFIG_BYTE
	mov	di,3ch
	int	1Ah
	MOV	byte ptr DGROUP:IRQ,CL			     ;report IRQ

	mov	BH,byte ptr ds:[BUSNO]	       ;Bus Number
	mov	BL,byte ptr ds:[BUSNO+1]       ;Device Number in upper 5 bit
	shl	BL,1
	shl	BL,1
	shl	BL,1
	and	bl,0f8h 		;Function Number in lower 3 bit

	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID			; Vendor ID
	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,10h
	int	1Ah
	and	cl,11111110b
	mov	ax,cx		;report IObase
	push	ax
	MOV	CS:IOBase,AX			; report IOBase

	jmp	RTL8139_Adapter
	mov	cx,0
	mov	si, Offset IOBuffer		;
Which_Sub_Vender_ID:
	add	si,cx
	add	si,cx
	cmp	ax,[si] 			;
	je	Update_Sub_Vender_ID
	inc	cx
	cmp	cx,4
	jbe	Which_Sub_Vender_ID
	mov	cx,0
Update_Sub_Vender_ID:
	mov	di,offset Sub_Vender_ID 	;
	add	di,cx
	mov	bl,byte ptr [di]
	mov	Sub_Vender_ID,bl

RTL8139_Adapter:

	mov	SlotFlag,1

	pop	ax		;restore ax=iobase
Not_RTL8139_Adapter:


ELSE
.386P
	mov	BH,byte ptr ds:[BUSNO]	       ;Bus Number
	mov	BL,byte ptr ds:[BUSNO+1]       ;Device Number in upper 5 bit
	shl	BL,1
	shl	BL,1
	shl	BL,1
	and	bl,0f8h 		;Function Number in lower 3 bit

	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID			; Vendor ID
	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,02h

	pushf
	call ds:[BIOSServiceEntry]		;equal call int 1AH
	cmp	cx,8139h
	je	Test_Device_Ok

	mov	SlotFlag,0			;Slot Function Fail
	jmp	Not_RTL8139_Adapter
Test_Device_Ok:
	mov	BH,byte ptr DS:[BUSNO]	    ;Bus Number
	mov	BL,byte ptr DS:[BUSNO+1]       ;Device Number in upper 5 bit
	shl	BL,1
	shl	BL,1
	shl	BL,1
	and	bl,0f8h 		;Function Number in lower 3 bit

	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID			; Vendor ID

	mov	ah, PCI_FUNCTION_ID
	mov	al, READ_CONFIG_BYTE
	mov	di,3ch
	pushf
	call	ds:[BIOSServiceEntry]

	MOV	byte ptr DGROUP:IRQ,CL			     ;report IRQ

	mov	BH,byte ptr ds:[BUSNO]	       ;Bus Number
	mov	BL,byte ptr ds:[BUSNO+1]       ;Device Number in upper 5 bit
	shl	BL,1
	shl	BL,1
	shl	BL,1
	and	bl,0f8h 		;Function Number in lower 3 bit

	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID			; Vendor ID
	mov	ah,PCI_FUNCTION_ID
	mov	al,READ_CONFIG_WORD
	mov	di,10h
	pushf
	call ds:[BIOSServiceEntry]
	and	cl,11111110b
	mov	ax,cx
     ;	MOV	word ptr CS:IOBASE,ax			 ;report IRQ


RTL8139_Adapter:

	mov	SlotFlag,1


Not_RTL8139_Adapter:

.286P
ENDIF
	cmp	SlotFlag,1
	jne	NoSlotSpecified
	jmp	SearchSlotDone

NoSlotSpecified:

	cmp	IDflag,1
	jne	Show_Slot_ERROR

Show_ID_ERROR:
       pushc   <WORD PTR STDOUT>
       pushc   <WORD PTR IDNotMatchMsgLen>
       push    ds
       pushc   <OFFSET DGROUP:IDNotMatchMsg>
       call    DOSPUTMESSAGE

Show_SLOT_ERROR:

	cmp	SlotFlag,1
	je	Show_ERROR_END
       pushc   <WORD PTR STDOUT>
       pushc   <WORD PTR SLOTNotMatchMsgLen>
       push    ds
       pushc   <OFFSET DGROUP:SLOTNotMatchMsg>
       call    DOSPUTMESSAGE

Show_ERROR_END:

	jmp	Error8139

SearchIDDone:

	mov	si,offset IRQBuffer
	add	si,cx
	mov	al,[si]
	mov	ah,0

	MOV	DGROUP:IRQ,AX			    ;report IRQ

	mov	si,offset IOBuffer
	add	si,cx
	add	si,cx
	mov	ax,[si]

SearchSlotDone:
IFDEF	DOS

	MOV	CS:IOBase,AX			; report IOBase
ELSE

	;************************ <OS/2> **************************
	; Subject : Change the value in Code segment
	;----------------------------------------------------------
	; NOTE : You can not modify the value in Code segment
	;	 directly under OS/2
	;----------------------------------------------------------
	PUSH	DS			;reserve ds
	PUSH	ES			;reserve es
	push	si
	push	dx
	push	cx
	PUSH	AX			;reserve AX

	push	ds			;mov cs into ds
	pop	es
	push	cs			;mov cs into ds
	pop	ds
	mov	si,0			;start of segment
	mov	DL, DEVHLP_VIRTTOPHYS	;convert CS to physical
	call	es:[Device_Help]	   ;phys addr in ax:bx

	mov	cx,0			;64K segment
	mov	dh,0			;result in DS
	mov	dl, DEVHLP_PHYSTOVIRT
	call	es:[Device_Help]

	push	ds			;use ES to write values
	pop	es			;so linker doesn't complain
	POP	AX			;recover AX
	MOV	ES:IOBase,AX		; report IOBase
	mov	ax,es
	pop	cx
	pop	dx
	pop	si
	POP	ES			;recover ES
	POP	DS			;recover DS

	;************************ <OS/2> **************************
ENDIF

	jmp	WeAreDone

No8139:
	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR No8139DosMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:No8139DosMsg>
	call	DOSPUTMESSAGE

Error8139:
	MOV	AX, REG_ERR	       ; error exit
	POP	BX		       ;
	POP	ES		       ;
	ret			       ;
WeAreDone:
	MOV	AX, SUCCESS
	POP	BX
	POP	ES
	ret
L_ENDP		ParseImageFdDev

;*************************** } Jasper 09/16/94	*****************************



;***************  -------------    **************
;***************  FORCE 100/10M    **************
;***************  -------------    **************

public FORCE100

FORCE100 PROC Near

	mov	dx,ds:nicIDR0		 ;test have n way hub
	add	dx,62h
	cmp	duplex,1
	jne	f_half_8139
	mov	ax, 2100h
	jmp	f_full_con
f_half_8139:
	mov	ax, 2000h
f_full_con:
	out	dx, ax

RET
 FORCE100  ENDP


public FORCE10

FORCE10  PROC Near

	mov	dx,ds:nicIDR0		 ;test have n way hub
	add	dx,62h
	cmp	duplex,1
	jne	f10_half_8139
	mov	ax, 0100h
	jmp	f10_full_con
f10_half_8139:
	mov	ax, 0000h
f10_full_con:
	out	dx, ax
	RET

 FORCE10   ENDP



;   AutoDetected Flow
;

Public		AutoDetected
L_PROC		AutoDetected
.386P
	push	eax
	push	bx
	push	cx


;****************************************************************
;****************************************************************
;****************************************************************
	mov	dx,ds:nicIDR0		 ;test have n way hub
	add	dx,62h

	in	ax,dx
	test	ax,1000h		 ;test ANE enable bit (12 bit)
	jnz	N_Way_Enable

;********* Not N Way Mode ***********
	cmp	Force_flag,0
	jne	force_flag_true

					;and set medium mode.
	test	ax,0100h		;test duplex mode (Full/Half)
	jz	test_speed_mode

;********* Full duplex mode *********


					;Medium value:
					;0:Auto
					;1:10Half
					;2:10full
					;3:100full
					;4:100full

	test	ax,2000h		;test speed mode (100/10)
	jz	@F
	mov	Medium,4		;100full
	jmp	half
@@:
	mov	Medium,2		;10full
half:
	jmp	@F

test_speed_mode:
	test	ax,2000h
	jz	speed_low
	mov	Medium,3		;100 half
	jmp	@F
speed_low:

	mov	Medium,1		;10 half

@@:
	mov	Force_flag,1

force_flag_true:

	mov	ax,1200h
	out	dx,ax

	mov	eax,(033333333d)*2	;2.0 sec  delay
	call	wait_pci

	jmp	@F

N_Way_Enable:

;***********  N Way Mode ***********
	cmp	Force_flag,0		;if n way mode and have keyword word
	jne	@F
	jmp	N_Way_End		;Yes , exit
@@:

	cmp	Medium,1
	jne	@F

	mov	ax,0021h		;10half
	jmp	test_link_ok
@@:
	cmp	Medium,2
	jne	@F

	mov	ax,0041h		;10full
	jmp	test_link_ok

@@:
	cmp	Medium,3
	jne	@F
	mov	ax,0081h		;100half
	jmp	test_link_ok
@@:
	cmp	Medium,4
	jne	@F
	mov	ax,0101h		;100full
	jmp	test_link_ok
@@:
	jmp	@F
test_link_ok:
	mov	dx,ds:nicIDR0
	add	dx,66h
	out	dx,ax
@@:
	mov	dx,ds:nicIDR0
	add	dx,74h
	in	ax,dx
	test	ax,0400h		;bit 10 link ok=1
	jnz	@F			;link ok
	jmp	N_Way_End		;link fail
@@:
	mov	dx,ds:nicIDR0
	add	dx,6Ah
	in	ax,dx
	test	ax,0001h		;Nway hub restart nway
	jz	N_Way_Force_Keyword

	mov	dx,ds:nicIDR0		; restart nway hub
	add	dx,62h
	mov	ax,1200h
	out	dx,ax
	mov	eax,(033333333d)*2	;2 sec	delay
	call	wait_pci
	jmp	N_Way_End

N_Way_Force_Keyword:
	cmp	Medium,0
	jne	@F
	mov	ax,1000h		;Auto
	jmp	test_link_ok_1
@@:
	cmp	Medium,1
	jne	@F
	mov	ax,0000h		;10half
	jmp	test_link_ok_1
@@:
	cmp	Medium,2
	jne	@F
	mov	ax,0100h		;10full
	jmp	test_link_ok_1
@@:
	cmp	Medium,3
	jne	@F
	mov	ax,2000h		;100half
	jmp	test_link_ok_1
@@:
	cmp	Medium,4
	jne	@F
	mov	ax,2100h		;100full
	jmp	test_link_ok_1
@@:
	jmp	N_Way_End
test_link_ok_1:

	mov	dx,ds:nicIDR0
	add	dx,62h
	out	dx,ax


N_Way_End:

;****************************************************************
;****************************************************************
;****************************************************************

	mov	eax,(033333333d)/2    ;0.5 sec	delay
	call	wait_pci

	mov	dx,ds:nicIDR0
	add	dx,74h
	in	ax,dx
	test	ax,0400h		;bit 10 link ok=1
	jz	Show_Link_Down		;link down


	mov	dx,ds:nicIDR0
	add	dx,58h			;in speed mode
	in	ax,dx
	mov	bx,ax			;put it in bx register

	mov	dx,ds:nicIDR0
	add	dx,62h
	in	ax,dx
	test	ax,0100h		;duplex bit
	jz	Half_Duplex_Test

	test	bx,0008h		;speed bit
	jnz	show_10_full
	jmp	show_100_full

Half_Duplex_Test:

	test	bx,0008h		;speed bit
	jnz	show_10_half
	jmp	show_100_half


show_100_Full:
	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR RTF100MFullMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:RTF100MFullMsg>
	call	DOSPUTMESSAGE
	jmp	Exit_Detect

show_10_full:

	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR RTF10MFullMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:RTF10MFullMsg>
	call	DOSPUTMESSAGE

	jmp	Exit_Detect

show_100_half:
	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR RTF100MHalfMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:RTF100MHalfMsg>
	call	DOSPUTMESSAGE
	jmp	Exit_Detect

show_10_half:
	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR RTF10MHalfMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:RTF10MHalfMsg>
	call	DOSPUTMESSAGE
	jmp	Exit_Detect

Show_Link_Down:

	;show	link detected fail
	pushc	<WORD PTR STDOUT>
	pushc	<WORD PTR LinkFailMsgLen>
	push	ds
	pushc	<OFFSET DGROUP:LinkFailMsg>
	call	DOSPUTMESSAGE

Exit_Detect:

	pop	cx
	pop	bx
	pop	eax
	ret
L_ENDP		AutoDetected





; Convert ID string buffer to hex
L_PROC		ConvertID
	push	cx
	push	si
	push	di
	mov	si,offset ID_Buffer
	mov	di,offset ID_USER
	mov	cx,0
ConvertIDLoop:
	mov	al,[si]
	cmp	al,0
	je	ConvertIDDone
	cmp	al,' '
	je	GetNextID
	cmp	al,0ah
	je	GetNextID
	cmp	al,0dh
	je	GetNextID
	cmp	al,09h
	je	GetNextID
	cmp	al, 30h
	jb	ConvertIDFail
	cmp	al, 3ah
	jb	C1
	cmp	al, 41h
	jb	ConvertIDFail
	cmp	al, 47h
	jb	C1
	cmp	al, 61h
	jb	ConvertIDFail
	cmp	al, 67h
	jae	ConvertIDFail
	sub	al, 20h
C1:
	test	cx,1
	jnz	C2
	mov	ah,al
	jmp	C7
C2:
	cmp	al,'9'
	ja	C3
	sub	al,'0'
	jmp	C4
C3:
	sub	al,'A'-10
C4:
	cmp	ah,'9'
	ja	C5
	sub	ah,'0'
	jmp	C6
C5:
	sub	ah,'A'-10
C6:
	shl	ah,1
	shl	ah,1
	shl	ah,1
	shl	ah,1

	add	al,ah
	mov	[di],al
	inc	di
C7:
	inc	cx
	cmp	cx,12
	je	ConvertIDDone
GetNextID:
	inc	si
	jmp	ConvertIDLoop


ConvertIDDone:
	pop	di
	pop	si
	pop	cx
	clc
	ret

ConvertIDFail:
	pop	di
	pop	si
	pop	cx
	stc
	ret

L_ENDP		ConvertID


; Convert ID string buffer to hex
L_PROC		ConvertID2
	push	cx
	push	si
	push	di
	mov	si,ax
	mov	di,offset SlotBuffer
	mov	cx,0
	mov	ah,0
ConvertIDLoop2:
	mov	al,byte ptr DS:[si]
	cmp	al,0
	je	ConvertIDDone2
	cmp	al,' '
	je	GetNextID2
	cmp	al,0ah
	je	GetNextID2
	cmp	al,0dh
	je	GetNextID2
	cmp	al,09h
	je	GetNextID2
	cmp	al, 30h
	jb	ConvertIDFail2
	cmp	al, 3ah
	jb	C11
	cmp	al, 41h
	jb	ConvertIDFail2
	cmp	al, 47h
	jb	C11
	cmp	al, 61h
	jb	ConvertIDFail2
	cmp	al, 67h
	jae	ConvertIDFail2
	sub	al, 20h
C11:
C22:
	cmp	al,'9'
	ja	C33
	sub	al,'0'
	jmp	C44
C33:
	sub	al,'A'-10
C44:
	cmp	ah,'9'
	ja	C55
	sub	ah,'0'
	jmp	C66
C55:
	sub	ah,'A'-10
C66:
	shl	ah,1
	shl	ah,1
	shl	ah,1
	shl	ah,1

	add	al,ah
	mov	[di],al
	inc	di
C77:
	inc	cx
	cmp	cx,2
	je	ConvertIDDone2

GetNextID2:
	inc	si
	jmp	ConvertIDLoop2


ConvertIDDone2:
	pop	di
	pop	si
	pop	cx
	clc
	ret

ConvertIDFail2:
	pop	di
	pop	si
	pop	cx
	stc
	ret


L_ENDP		ConvertID2


; Read adapter ID and compare with ID we get from protocol.ini
L_PROC		CompareID
	push	bp
	push	di
	push	cx
	mov	cx,0
	mov	si,offset ID_USER
CompareIDLoop:
	in	ax,dx

	cmp	ax,[si]
	jne	CompareIDFail
	add	si,2
	add	cx,2
	add	dx,2
	cmp	cx,6
	je	CompareIDDone
	jmp	CompareIDLoop
CompareIDDone:
	pop	cx
	pop	di
	pop	bp
	clc
	ret
CompareIDFail:
	pop	cx
	pop	di
	pop	bp
	stc
	ret

L_ENDP		CompareID



COMMENT^

-------------------------------------------------------------------------------
$Name: GetHWParams - Get the hardware parameters of the board
-------------------------------------------------------------------------------

$Description:
Get H/W parameters
$

$Method:
$
^

L_PROC		GetHWParams
;check IOBase

	mov	ax, SUCCESS  ; no error

	ret
L_ENDP	GetHWParams

init_test	proc near
.386P

	;
	; setup Port Address
	;
SetupIOPortAddress:
	mov	bx,cs:iobase
	lea	ax,[bx+IDR0]
	mov	DS:NICIDR0,ax

	lea	ax,[bx+IDR4]
	mov	DS:NICIDR4,ax

	lea	ax,[bx+MAR0]
	mov	DS:NICMAR0,ax

	lea	ax,[bx+MAR4]
	mov	DS:NICMAR4,ax

	lea	ax,[bx+TSD0]
	mov	DS:NICTSD0,ax

	lea	ax,[bx+TSD1]
	mov	DS:NICTSD1,ax

	lea	ax,[bx+TSD2]
	mov	DS:NICTSD2,ax

	lea	ax,[bx+TSD3]
	mov	DS:NICTSD3,ax

	lea	ax,[bx+TSAD0]
	mov	DS:NICTSAD0,ax

	lea	ax,[bx+TSAD1]
	mov	DS:NICTSAD1,ax

	lea	ax,[bx+TSAD2]
	mov	DS:NICTSAD2,ax

	lea	ax,[bx+TSAD3]
	mov	DS:NICTSAD3,ax

	lea	ax,[bx+RBSTART]
	mov	DS:NICRBSTART,ax

	lea	ax, [bx+ERBCR]
	mov	DS:NICERBCR,ax

	lea	ax,[bx+ERSR]
	mov	DS:NICERSR,ax

	lea	ax,[bx+CMD]
	mov	DS:NICCMD,ax

	lea	ax,[bx+CAPR]
	mov	DS:NICCAPR,ax

	lea	ax,[bx+IMR]
	mov	DS:NICIMR,ax

	lea	ax,[bx+ISR]
	mov	DS:NICISR,ax

	lea	ax,[bx+TCR]
	mov	DS:NICTCR,ax

	lea	ax,[bx+RxCR]
	mov	DS:NICRCR,ax

	lea	ax,[bx+TCTR]
	mov	DS:NICTCTR,ax

	lea	ax,[bx+MPC]
	mov	DS:NICMPC,ax

	lea	ax,[bx+CR9346]
	mov	DS:NICCR9346,ax

	lea	ax,[bx+CONFIG0]
	mov	DS:NICCONFIG0,ax

	lea	ax,[bx+CONFIG1]
	mov	DS:NICCONFIG1,ax

	lea	ax,[bx+FLASH]
	mov	DS:NICFLASH,ax

	lea	ax,[bx+GEP]
	mov	DS:NICGEP,ax

	lea	ax,[bx+GEPCTL]
	mov	DS:NICGEPCTL,ax

	lea	ax,[bx+MIIR]
	mov	DS:NICMIIR,ax


	lea	ax,[bx+MII0]
	mov	DS:NICMII0,ax

	lea	ax,[bx+HLTCLK]
	mov	DS:NICHLTCLK,ax

	lea	ax,[bx+TSAD]
	mov	DS:NICTSAD,ax

	lea	ax,[bx+FIFOTMS]
	mov	DS:NICFIFOTMS,ax

	lea	ax,[bx+FIFOTMD]
	mov	DS:NICFIFOTMD,ax

	lea	ax,[bx+CLRCACHE]
	mov	DS:NICCLRCACHE,ax

	lea	ax,[bx+MIIR]
	mov	DS:NICMIIR,ax
	;

	mov	dx, DS:NICIMR
	mov	ax, 0
	out	dx, ax

IFDEF	DOS
	; setup Transmit buffer start address
	;**** TSAD0 *****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage0
	mov	TXDmaDescriptor0.RegionOffset, eax
	mov	TXDmaDescriptor0.RegionSegment, DS
	mov	TXDmaDescriptor0.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor0
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor0.PhysicalAddress
	mov	pTxStartAddrPage0, eax
;	 mov	 dx, DS:NICTSAD0
;	 out	 dx, eax

	;**** TSAD1 ****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage1
	mov	TXDmaDescriptor1.RegionOffset, eax
	mov	TXDmaDescriptor1.RegionSegment, DS
	mov	TXDmaDescriptor1.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor1
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor1.PhysicalAddress
	mov	pTxStartAddrPage1, eax
;	 mov	 dx, DS:NICTSAD1
;	 out	 dx, eax


	;**** TSAD2 ****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage2
	mov	TXDmaDescriptor2.RegionOffset, eax
	mov	TXDmaDescriptor2.RegionSegment, DS
	mov	TXDmaDescriptor2.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor2
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor2.PhysicalAddress
	mov	pTxStartAddrPage2, eax
;	 mov	 dx, DS:NICTSAD2
;	 out	 dx, eax


	;**** TSAD3 ****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage3
	mov	TXDmaDescriptor3.RegionOffset, eax
	mov	TXDmaDescriptor3.RegionSegment, DS
	mov	TXDmaDescriptor3.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor3
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor3.PhysicalAddress
	mov	pTxStartAddrPage3, eax
;	 mov	 dx, DS:NICTSAD3
;	 out	 dx, eax

	;**** TSAD4 *****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage4
	mov	TXDmaDescriptor4.RegionOffset, eax
	mov	TXDmaDescriptor4.RegionSegment, DS
	mov	TXDmaDescriptor4.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor4
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor4.PhysicalAddress
	mov	pTxStartAddrPage4, eax

	;**** TSAD5 ****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage5
	mov	TXDmaDescriptor5.RegionOffset, eax
	mov	TXDmaDescriptor5.RegionSegment, DS
	mov	TXDmaDescriptor5.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor5
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor5.PhysicalAddress
	mov	pTxStartAddrPage5, eax


	;**** TSAD6 ****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage6
	mov	TXDmaDescriptor6.RegionOffset, eax
	mov	TXDmaDescriptor6.RegionSegment, DS
	mov	TXDmaDescriptor6.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor6
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor6.PhysicalAddress
	mov	pTxStartAddrPage6, eax


	;**** TSAD7 ****

	xor	eax, eax
	mov	ax, offset DS: TxStartAddrPage7
	mov	TXDmaDescriptor7.RegionOffset, eax
	mov	TXDmaDescriptor7.RegionSegment, DS
	mov	TXDmaDescriptor7.RegionSize, 1600

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, TXDmaDescriptor7
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,TXDmaDescriptor7.PhysicalAddress
	mov	pTxStartAddrPage7, eax


;
; setup Receive buffer start address
;

	xor	eax, eax
	mov	ax, offset DS: RxBufferStartAddr
	mov	RXDmaDescriptor.RegionOffset, eax
	mov	RXDmaDescriptor.RegionSegment, DS
	mov	RXDmaDescriptor.RegionSize, 1024*8

	; Calculate Physical address of RxResourcesPool
	;----------------------------------------------

	lea	di, RXDmaDescriptor
	call	VDSLockMemoryAndGetPhysicalAddress
	mov	eax,RXDmaDescriptor.PhysicalAddress
	mov	dx, DS:NICRBSTART
	out	dx, eax
 else
	mov	si, offset DS: TxStartAddrPage0
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]  ;hiword	ax
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage0, eax

	mov	si, offset DS: TxStartAddrPage1
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage1, eax

	mov	si, offset DS: TxStartAddrPage2
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage2, eax

	mov	si, offset DS: TxStartAddrPage3
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage3, eax

	mov	si, offset DS: TxStartAddrPage4
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]  ;hiword	ax
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage4, eax

	mov	si, offset DS: TxStartAddrPage5
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage5, eax

	mov	si, offset DS: TxStartAddrPage6
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage6, eax

	mov	si, offset DS: TxStartAddrPage7
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	pTxStartAddrPage7, eax

;
; setup Receive buffer start address
;
	mov	si, offset DS: RxBufferStartAddr
	mov	dl,DevHlp_VirtToPhys
	call	[Device_Help]
	and	eax,0000ffffh
	shl	eax,16
	mov	ax,bx
	mov	dx, DS:NICRBSTART
	out	dx, eax
 ENDIF
; set parameter
;;;;8139 version 2.00 ;;v200;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;; check link on;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	loadport
;	setport RTL_74



	mov	dx, (DS:NICIDR0)
	add	dx, 074h
	in	ax,dx
	test	ax,SIZE16_BIT10
	jz	no_link_v200
  ;	SHOW_EVENT	'o'
  ;	SHOW_EVENT	'n'
 ifdef debug5
	push	ax
	mov	al, 'O'
;	 call	 show_char
	mov	al, 'N'
;	 call	 show_char
	pop	ax
 endif

	mov	ax, 003c0h		;enable Turbo link
	mov	dx, (DS:NICIDR0)
	add	dx, 074h
	out	dx, ax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;link on and delay 100MS  ;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	eax,(033333333d)/10    ;1/10 sec  delay
	call wait_pci

  ;	loadport
  ;	setport RTL_74

	mov	dx, (DS:NICIDR0)
	add	dx, 074h

	in	ax,dx
	and	ax, (SIZE16_BIT12+SIZE16_BIT13+SIZE16_BIT14)
	cmp	ax, 0
	jnz	next_v200_1
    ;	SHOW_EVENT	'a'
 ifdef debug5
	push	ax
	mov	al, '0'
;	 call	 show_char
	pop	ax
 endif

	mov	bx,0
	call	set_param

	jmp	con_step4_v200
next_v200_1:

	cmp	ax, SIZE16_BIT12
	jnz	next_v200_3
   ;	SHOW_EVENT	'b'
 ifdef debug5
	push	ax
	mov	al, '1'
;	 call	 show_char
	pop	ax
 endif
	mov	bx,1
	call	set_param

	jmp	con_step4_v200
next_v200_3:

	cmp	ax,(SIZE16_BIT12+SIZE16_BIT13)
	jnz	next_v200_7
   ;	SHOW_EVENT	'c'
 ifdef debug5
	push	ax
	mov	al, '3'
;	 call	 show_char
	pop	ax
 endif
	mov	bx,3
	call	set_param

	jmp	con_step4_v200
next_v200_7:

	cmp	ax,(SIZE16_BIT12+SIZE16_BIT13+SIZE16_BIT14)
	jnz	next_v200_8
    ;	SHOW_EVENT	'd'
 ifdef debug5
	push	ax
	mov	al, '7'
;	 call	 show_char
	pop	ax
 endif
	mov	bx,7
	call	set_param

	jmp	con_step4_v200
next_v200_8:
 ifdef debug5
	push	ax
	mov	al, 'E'
;	 call	 show_char
	mov	al, 'R'
;	 call	 show_char
	mov	al, 'R'
;	 call	 show_char
	pop	ax
 endif
    ;	SHOW_EVENT	'e'
    ;	SHOW_EVENT	'r'
    ;	SHOW_EVENT	'r'
	mov	bx,7
	call	set_param

	jmp	con_step4_v200
no_link_v200:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;; link down;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;	SHOW_EVENT	'd'
    ;	SHOW_EVENT	'n'
 ifdef debug5
	push	ax
	mov	al, 'D'
;	 call	 show_char
	mov	al, 'N'
;	 call	 show_char
	pop	ax
 endif
  ;  loadport
  ;  setport RTL_70


	mov	dx, (DS:NICIDR0)
	add	dx, 070h

	mov	eax, PARAM70
	out	dx,eax


;	loadport
;	setport RTL_78

	mov	dx, (DS:NICIDR0)
	add	dx, 078h

	mov	eax,PARAM78
	out	dx,eax

;	loadport
;	setport RTL_7C

	mov	dx, (DS:NICIDR0)
	add	dx, 07ch

	mov	eax, PARAM7C
	out	dx,eax

con_step4_v200:

;;;;8139 version 2.00 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;v200;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;1997/06/12 for 8139 twister parameter;;;;;;


	call	AutoDetected			;detecte Hub mode and Duplex
						;check keyword mode (Medium)
	mov	ax,0000h			;ok
		ret
init_test	endp



;
; CalculatePhysicalAddress
;
;      assumes:        ds:si = logical address
;		       In real mode => change to linear address.
;
;      returns:        eax = physical address of memory (32bits)
;
;      preserved:      bx, di, bp, es, ds
;
;
;

CalculatePhysicalAddress    proc
	push	cx			;

	mov	ax, si			; ax = offset
	mov	dx, ds			; dx = segment
	mov	cl, 4			;

	rol	dx, cl
	mov	cl, dl			;
	and	cl, 0fh 		;

	and	dl, 0f0h		;
	add	ax, dx			; ax: low word
	mov	dx, 0			;
	adc	dl, cl			; dx: high word
	shl	edx, 16
	and	eax, 0ffffh
	or	eax, edx

	pop	cx
	ret

CalculatePhysicalAddress	endp




;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;	VDSLockMemoryAndGetPhysicalAddress
;
;	Routine checks if VDS are enabled, if so it calls VDS to Lock the
;	memory region its pointed by the descriptor pointed by SI and gets its
;	physical address.
;	If VDS are disabled it calculates the physical address from seg:offset
;	using the conventional 8086 way.
;
;	assumes:	ds	is set to CGroup
;			CLD has been executed
;
;
;			di	Pointer to VDS_Structure containing the info on
;				The memory region to be locked and it's physical
;				address we wish to get.
;
;	returns:	Physical address of the memory (written in the same
;			structure). If VDS are enabled Locking of the memory.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
VDSLockMemoryAndGetPhysicalAddress PROC near

	push	es
	push	edx
	push	eax

	call	AreVDSServicesAvailale
	jc	SHORT NoVDSServicesAvailable

	;if reached this point VDS Are available - use them
	;--------------------------------------------------
	push	ds
	pop	es		      ;es:di -> DMA descriptor
	mov	ax, VDS_LOCK_REGION
	xor	edx, edx
	int	VDS_INTERRUPT
	jnc	SHORT LMAGPA_Exit
	jmp	SHORT LMAGPA_ErrorExit

NoVDSServicesAvailable:
	clc
	;Calculate Physical address in the Simple way
	;PhysicallAddress = (Segment << 4) + offset
	;--------------------------------------------
	xor	eax, eax
	mov	ax, [di].RegionSegment
	shl	eax, 4
	add	eax, [di].RegionOffset
	mov	[di].PhysicalAddress, eax

LMAGPA_Exit:
	pop	eax
	pop	edx
	pop	es
	ret
LMAGPA_ErrorExit:
	pop	eax
	pop	edx
	pop	es
						      ;in runtime !!!
	ret

VDSLockMemoryAndGetPhysicalAddress  ENDP

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;AreVDSServicesAvailale
;
;Checks if VDS services are enabled.
;Examine bit five (5) of the byte at 0040:007Bh.
;If the bit is set then should use the DMA services. Otherwise,
;the device can assume that all memory is mapped linear=physical.
;(Can be a dangerous assumption )
;	returns:
;		Carry	SET    If Services are NOT enabled
;			RESET  If Services are enabled
;	all registers are preserved
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
AreVDSServicesAvailale	PROC near
	push	ax
	push	es

	mov	ax, 40h 		;test byte at 40:7b
	mov	es, ax			;to see if VDS is supported
	clc
	test	BYTE PTR es:7Bh, 20h
	jnz	SHORT VDSServicesAvailable

	stc	;pws Z = No VDS
VDSServicesAvailable:
	pop	es
	pop	ax
	ret
AreVDSServicesAvailale	ENDP

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;	VDSUnlockMemory
;
;	Calls VDS services in order to unlock priviosly locked memory
;	proir freeing it or prior to program termination.
;	assumes:	ds	Holds CGROUP
;			di	Holds the effective address of	a DMA_Descriptor
;				structure holding the detailes about the memory
;				to be unlocked.
;	returns: noting
;	all registers are preserved
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
VDSUnlockMemory proc near

	call	AreVDSServicesAvailale
	jnc	SHORT VDSServicesAvailale
	clc
	ret				;No VDS -> NO need to unlock memory

VDSServicesAvailale:
	push	ax
	push	dx
	push	es

	push	ds
	pop	es				;es=ds
	mov	ax, VDS_UNLOCK_REGION
	xor	dx, dx
	int	VDS_INTERRUPT

	pop	es
	pop	dx
	pop	ax
	ret
VDSUnlockMemory 	ENDP

;----------------------------------------------------------------------------
;Name: FindBoardName  Find Driver Name
;----------------------------------------------------------------------------


L_PROC	 FindBoardName

IFDEF	DOS

;	Is PCI system ?
	mov	ah, PCI_FUNCTION_ID
	mov	al, PCI_BIOS_PRESENT
	int	1Ah
	pushf
	pop	dx
	test	dx, 0001h
	jz	PCI_system1

	jmp	FindBoardExit

PCI_system1:
	mov	 NumOf8139,0			 ; Increment adapter count
	mov	 si,0h

FindBoardNum:
;	Find our device
	mov	ah, PCI_FUNCTION_ID
	mov	al, FIND_PCI_DEVICE
	mov	cx, RTL_PCI_ID			     ; device ID
	mov	dx, RTL_VENDOR_ID		; Vendor ID
	int	1Ah
	cmp	ah,0h				;succesful
	jne	Not_Find_Board

	inc	NumOf8139			; Increment adapter count


Not_Find_Board:
	inc	si
	cmp	si,11h			;there are 16 possible device in pci
	jbe	FindBoardNum


ELSE						; 12/20/94

;============= Begin OS/2 Seach 8139 ==========

;97.1.22
	mov	ax, (PCI_BIOS_INT_ADDR SHR 16) ; high-order part of physical addr.
	mov	bx, 0			; start of that segment
	mov	cx, 0			; map full 64KB
	mov	dh, UVIRT_RE		; make it executable-readable
	mov	dl, DEVHLP_PHYSTOUVIRT	; function to get virtual address
	call	ds:[device_HELP]	; get it
	jnc	PCI_System1		; branch on error

	jmp	FindBoardExit

PCI_system1:

	add	 bx, (PCI_BIOS_INT_ADDR AND 0FFFFh) ; low-order part of phys addr
	mov	 BIOSServiceEntry._off, bx  ; save entry point offset
	mov	 BIOSServiceEntry._seg, es  ; save entry point segment


	mov	 NumOf8139,0		; Increment adapter count
	mov	 si,0h

FindBoardNum:
	;Find our device
	mov	ah, PCI_FUNCTION_ID
	mov	al, FIND_PCI_DEVICE
	mov	cx, RTL_PCI_ID		; device ID
	mov	dx, RTL_VENDOR_ID	; Vendor ID

	pushf
	call ds:[BIOSServiceEntry]

	cmp	ah,0h			;succesful
	jne	Not_Find_Board

	;if it is our 8139 save it config

	inc	NumOf8139		; Increment adapter count


Not_Find_Board:
	inc	si
	cmp	si,11h		;there are 16 possible device in pci
	jae	@F
	jmp	FindBoardNum

@@:
ENDIF

	cmp	NumOf8139,1
	ja	@F
	jmp	FindBoardExit
@@:



	 ; 1 represent GetProtocolManagerInfo
	mov	protreq.pm_opcode,1	   ;opcode for call

IFDEF	DOS				   ;DOS
	mov	ah,3dh			   ;open the device
	mov	al,40h			   ;Deny None, Read Only
	mov	dx, OFFSET DGROUP:protdev  ;device name
	int	21h			   ;return file handle
	mov	filehandle,ax		   ;get the file handle
	jnc	@F			   ;check for error
	mov	ax,PROTMGR_ERR		   ;error - with carry
	ret

@@:	mov	ah,44h			   ;IOCTL req
	mov	al,02h			   ;device input
	mov	dx,OFFSET DGROUP:protreq   ;pointer to reqblock
	mov	cx,14			   ;size of ReqBlock
	mov	bx,filehandle
	int	21h			   ;call DOS


ELSE						   ;OS/2
;open the protocol manager
	push	ds
	pushc	<OFFSET DGROUP:protdev>
	push	ds
	pushc	<OFFSET DGROUP:filehandle>
	push	ds
	pushc	<OFFSET DGROUP:action>
	pushc	<WORD PTR 0>
	pushc	<WORD PTR 0>
	pushc	<WORD PTR READONLY_FILE>
	pushc	<WORD PTR (NOTEXIST_FAIL OR EXIST_OPEN)>
	pushc	<WORD PTR (DENY_NONE OR READ_ONLY)>
	pushc	<WORD PTR 0>
	pushc	<WORD PTR 0>
	call	DOSOPEN

	cmp	ax,0		;open ok?
	je	@F
	mov	ax,PROTMGR_ERR
	ret

@@:	pushc	0			;pointer to data area
	pushc	0
	push	ds
	pushc	<OFFSET DGROUP:protreq>
	pushc	PMGR_IOCTL_FUNC
	pushc	PMGR_CATEGORY
	push	filehandle
	call	DOSDEVIOCTL
ENDIF
	mov	ax,protreq.pm_status	   ;get status
	xor	ah,ah			   ;clear ah
	cmp	ax, SUCCESS
	je	@F

IFDEF	DOS				   ;DOS
	mov	ah,3eh			   ;open the device
	mov	bx,DGROUP:filehandle
	int	21h			   ;return file handle
ENDIF

IFNDEF	 DOS				    ;DOS
	push	ax
	pushc	<OFFSET DGROUP:filehandle>
	call	DOSCLOSE
	pop	ax

ENDIF
	mov	ax,REG_ERR
	ret


@@:
	MOV	Si, OFFSET DGroup:DriverName; point to offset of Dr
	MOV	DI, OFFSET DGroup:YDriverName; point to offset of
	mov	cx,10h
MovDriveNam2:
	mov	al, byte ptr DGroup:[si]
	mov	byte ptr DGroup:[di],al
	cmp	byte ptr DGroup:[si],'$'
	je	MovDriveNam_2
	inc	si
	inc	di
	loop	MovDriveNam2
MovDriveNam_2:
	inc	di
	mov	byte ptr [di],0


	MOV	AX, ProtReq.pm_ptr1._SEG   ;get image pointer
	MOV	MemoryImagePtr._HI, AX
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX
	MOV	AX, ProtReq.pm_ptr1._OFF
	MOV	MemoryImagePtr._LO, AX
	MOV	BX, AX

	ADD	BX, mc_keyword		   ;get keyword pointer
	MOV	MemoryImagePtr2._LO, BX
; Now, ES:BX is the image pointer

Next_Module1:
	ADD	BX, kw_keyword		   ; driver name in image
;Compare driver name with RTL8139
	MOV	DI, BX
	MOV	SI, OFFSET DGroup:xDriverName; point to offset of Dr

NextKeyWord1:
	SUB	DI, kw_keyword
	ADD	DI, kw_param		   ;goto paramter pointer
	ADD	DI, pm_num		   ;get parameter
	push	si
	push	di
	CALL	StringCompare		   ; compare driver name
	CMP	AX, SUCCESS
	pop	di
	pop	si
	jnz	Find_Next_Keyword1
	push	ax
	push	cx
	push	si
	push	di
 IFDEF	 DOS
	push	es
	push	ax
	push	bx
	mov	ax,0
	mov	es,ax
	xor	bx,bx
	mov	bl,[BrdNum]
	dec	bl
	cmp	byte ptr es:[180h][bx],'Y'

	pop	bx
	pop	ax
	pop	es

	jne	Check_First_Driver_Name
 ELSE
	cmp	byte ptr es:[di-2],'Y'
	jne	Check_First_Driver_Name
 ENDIF
	inc	BrdNum		;add drivername
	push	si
	mov	cx,10
  Check_Driver1:
	cmp	byte ptr [si],'$'
	je	Find_KeyWord1
	inc	si
	loop	Check_Driver1
  Find_Keyword1:
	mov	al,[BrdNum]
	add	al,30h
	mov	[si],al
	mov	[si+1],byte ptr '$'
	pop	si

	pop	di
	pop	si
	pop	cx
	pop	ax
	jmp	Find_Next_keyword1
Check_First_Driver_Name:
 IFDEF	 DOS

	push	es
	push	ax
	push	bx
	mov	ax,0
	mov	es,ax
	xor	bx,bx
	mov	bl,[BrdNum]
	dec	bl
	mov	es:[180h][bx],byte ptr 'Y'

	pop	bx
	pop	ax
	pop	es

 ELSE
	mov	es:[di-2],byte ptr 'Y'

 ENDIF
	pop	di
	pop	si
	pop	cx
	pop	ax
	JMP	SetModuleName1

Find_Next_keyword1:

	MOV	di, MemoryImagePtr2._LO
	MOV	ax, MemoryImagePtr2._HI
	mov	es,ax
	ADD	di, kw_next
	MOV	AX, ES:[di]._SEG	   ;get next module pointer
	MOV	CX, ES:[di]._OFF	   ;get next module pointer
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX			   ;update ES
	MOV	MemoryImagePtr2._LO, CX
	MOV	di, CX			   ;update BX
	ADD	di, kw_keyword		   ; driver name in image
	OR	AX, CX			   ;check null pointer
	JZ	NOT_STRING1
	jmp	NextKeyWord1
SetModuleName1:
	jmp	ModuleOver1


NOT_STRING1:
	MOV	BX,MemoryImagePtr._LO
	MOV	ax, MemoryImagePtr._HI
	mov	es,ax
	ADD	BX, mc_next
	MOV	AX, ES:[BX]._SEG	   ;get next module pointer
	MOV	CX, ES:[BX]._OFF	   ;get next module pointer
	MOV	MemoryImagePtr._HI, AX
	MOV	MemoryImagePtr2._HI, AX
	MOV	ES, AX			   ;update ES
	MOV	MemoryImagePtr._LO, CX
	MOV	BX, CX			   ;update BX
	ADD	BX, mc_keyword		   ;get keyword pointer
	MOV	MemoryImagePtr2._LO, BX
;=======
	INC	DL
	OR	AX, CX			   ;check null pointer
	JZ	@F
	JMP	Next_Module1

@@:

IFDEF	DOS				   ;DOS
	mov	ah,3eh			   ;open the device
	mov	bx,DGROUP:filehandle
	int	21h			   ;return file handle
ENDIF
IFNDEF	 DOS				    ;DOS
	push	ax
	pushc	<OFFSET DGROUP:filehandle>
	call	DOSCLOSE
	pop	ax

ENDIF
	MOV	AX, BRD_NOT_FOUND
	RET

FindModule1:
	jmp	ModuleOver1

ModuleOver1:

IFNDEF		 DOS				    ;DOS
	push	ax
	pushc	<OFFSET DGROUP:filehandle>
	call	DOSCLOSE
	pop	ax
ENDIF

FindBoardExit:

	ret

L_ENDP		FindBoardName


INITCODESEG_END

END
