COMMENT ^

File Name : RECEIVE.ASM

This module handles packet reception. It contains routines to call the
protocol's ReceiveLookahead function, handle TransferData requests, and
to handle receiver overflow. It contains a routine to pass as many
received packets as possible to the protocol.  It also contains the
IndicationOn and IndicationOff routines.

^

INCLUDE macros.inc
INCLUDE vector.inc
INCLUDE os2defs.inc
INCLUDE dp8139.inc
INCLUDE RTL8139.inc
INCLUDE devhdr.inc

IFNDEF  DOS                             ;286 protected mode needed to
.386P                                   ;examine machine status word
ENDIF                                   ;under OS/2

;==============================================================================
DATASEG_BEG


EXTRN   CommChar:WORD, ProtDS:WORD, MacStat:WORD, ServStat:WORD
EXTRN   NICCMD:WORD,NICRBSTART:WORD,NICCAPR:WORD,NICTCR:WORD,NICMAR0:word,NICMAR4:word
EXTRN   NICRCR:WORD,NICIMR:WORD,NICCR9346:WORD,NICCAPR:WORD,NICERBCR:WORD
EXTRN   RESV1:dword,RESV2:dword,RESV3:dword,NICISR:WORD,nicersr:word
EXTRN   CurRxBufAddr:Word ,DataPrefetchFlag :Byte
EXTRN   RxBurstDMA:word,TxBurstDMA:WORD,RxBufferStartAddr:Byte
EXTRN   NICGEP:word
EXTRN   Device_Help:DWORD
EXTRN   segRX:WORD,BrdNum:byte
EXTRN   Sub_Vender_ID:byte
;extrn   show_char:near,show_char1:near,show_char2:near
;extrn   disp_hex2:near,disp_hex4:near
extrn   TCSNextToFill:word,TCSNextToXmit:word,TCSNextToTOK:word,TxStartAddrPage0 :byte
extrn   Tx_Cont_Block:word
extrn   TxCount:byte
extrn   XmitCount:byte
extrn   pchar:near,pbyte:near

;inserted on 2006/02/13	begin
extrn	BUS_NUM:byte,DEV_NUM:byte

PCI_FUNCTION_ID		equ	0B1h
PCI_BIOS_PRESENT	equ	01h
FIND_PCI_DEVICE		equ	02h
READ_CONFIG_BYTE	equ	08h
READ_CONFIG_WORD	equ	09h
READ_CONFIG_DWORD	equ	0ah
WRITE_CONFIG_BYTE	equ	0Bh
WRITE_CONFIG_WORD	equ	0ch
WRITE_CONFIG_DWORD	equ	0dh
;inserted on 2006/02/13	end

PUBLIC  LookAheadValue
public  RxBufBoundary

EXTRN   pTxStartAddrPage0:dword,pTxStartAddrPage1:dword
EXTRN   pTxStartAddrPage2:dword,pTxStartAddrPage3:dword
EXTRN   pTxStartAddrPage4:dword,pTxStartAddrPage5:dword
EXTRN   pTxStartAddrPage6:dword,pTxStartAddrPage7:dword

LookAhead       dw     ?
RxBufBoundary   dw     ?
RxCAPR          dw     0fff0h
LookAheadValue  dw     64D              ;a variable to maintain Look ahead
                                        ;value
LookAheadBuf    LABEL  BYTE
                ;db     1600 dup (?)     ;A buffer to store packet value

PUBLIC indicate,IndOffs
indicate        dw      ?               ;indication flag for protocol
IndOffs         db      0               ;# of indication offs received
IndCompFlag     db      0               ;1 if IndicationComplete needed
;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;
PUBLIC  IndicationComplete, ReceiveLookahead

IndicationComplete      dd      ?       ;vector to protocol's IndicationComplete routine
ReceiveLookahead        dd      ?       ;vector to protocol's Receive routine

CRC32_Table dd  260 dup(?)

CRC32           dd     ?
ErrorFlag       db     ?
TmpByte         db     ?
TmpDword        dd     ?
Count256        dw     ?
DATASEG_END
;==============================================================================
CODESEG_BEG
;This data is stored in the code segment because we need to access it
;when ds is not set. Since they are only written once, at initialization
;time, this isn't a big deal

EXTRN   IOBase:WORD
EXTRN   wait_pci:near


;==============================================================================

COMMENT ^

----------------------------------------------------------------------------
$Name: Reset 8139
----------------------------------------------------------------------------

^

PUBLIC ResetNIC
A_PROC          ResetNIC , near
        cli
        push    eax

        mov     dx, DS:NICIMR
        mov     ax, 0
        out     dx, ax

        mov     dx, ds:NICCMD
        mov     al, CMD_RST
        out     dx, al
        mov     ds:RxCAPR,0FFF0H

        mov     dx, DS:NICCMD
        mov     al, CMD_RE+CMD_TE
        out     dx, al

        mov     dx, DS:NICRCR
        xor     eax, eax
        mov     ax, RxBurstDMA

        add     eax, RCR_AB + RCR_APM + RCR_AM + RESV4
        out     dx, eax

        mov     dx, DS:NICTCR
        xor     eax, eax
        mov     ax, TxBurstDMA
        add     eax,03000000h
        out     dx, eax

;inserted on 2006/02/13 to disable interrupt disable (bit 10) in command register (offset 0x04) of PCI configuration space	begin
	mov	ah,PCI_FUNCTION_ID	;read the content of PCI configuration space offset 0x04 (command)
	mov	al,READ_CONFIG_WORD
	mov	bh,BUS_NUM
	mov	bl,DEV_NUM
	mov	di,04h
	int 	1Ah

	test	cx,0400h		;weather interrupt disable bit is 0 in PCI configuration space offset 0x04 (command)
	jz	interrupt_disable_off

	and	cx,0FBFFh		;disable the interrupt disable bit in PCI configuration space
	mov	ah,PCI_FUNCTION_ID
	mov	al,WRITE_CONFIG_WORD
	mov	bh,BUS_NUM
	mov	bl,DEV_NUM
	mov	di,04h
	int	1Ah
interrupt_disable_off:

;inserted on 2006/02/13 to disable interrupt disable (bit 10) in command register (offset 0x04) of PCI configuration space	end

 ;add by jack Oct.4.97 for Driver Load bit
        mov     dx,CS:IOBase
        add     dx,CR9346
        mov     al, CR9346_EEM1+CR9346_EEM0
        out     dx,al                           ;CONFIG1 R/W enable

        mov     dx,CS:IOBase
        add     dx,CONFIG1
        in      ax,dx
        or      al,20h
        out     dx,al

        mov     dx,CS:IOBase
        add     dx,CR9346
        mov     al, 0
        out     dx, al

;add by jack Oct.4.97 for Driver Load bit

                mov     ax, offset DS:RxBufferStartAddr
                mov     CurRxBufAddr, ax                ;reset rx start addr
                add     ax,2000h
                mov     DS:RxBufBoundary,ax
                mov     TxCount, 0
                mov     XmitCount, 0
                mov     cx, TxBufferNo            ;number of transmit buffers
                mov     si, OFFSET Tx_Cont_Block  ;current block
                mov     ax, OFFSET DS:TxStartAddrPage0 ;page num of xmt buffer
                mov     dl,0
FillTxBlock:    mov     bx,si                     ;get offset of next
                add     bx, SIZE Tx_Control       ;control structure
                mov     [si].TCS_Link,bx          ;set in structure
                mov     [si].TCS_Page,dl          ;Txmit Page (0 - 3)
                mov     [si].TCS_PStart,ax        ;page number of block
                mov     [si].TCS_Free, TCS_Avail  ;block is unused

                push    eax
                cmp     cx, 8
                je      TXP0

                cmp     cx, 7
                je      TXP1

                cmp     cx, 6
                je      TXP2

                cmp     cx, 5
                je      TXP3

                cmp     cx, 4
                je      TXP4

                cmp     cx, 3
                je      TXP5

                cmp     cx, 2
                je      TXP6

                mov     eax, DS:pTxStartAddrPage7
                jmp     FillPAddr

TXP0:
                mov     eax, DS:pTxStartAddrPage0
                jmp     FillPAddr
TXP1:
                mov     eax, DS:pTxStartAddrPage1
                jmp     FillPAddr
TXP2:
                mov     eax, DS:pTxStartAddrPage2
                jmp     FillPAddr
TXP3:
                mov     eax, DS:pTxStartAddrPage3
                jmp     FillPAddr
TXP4:
                mov     eax, DS:pTxStartAddrPage4
                jmp     FillPAddr
TXP5:
                mov     eax, DS:pTxStartAddrPage5
                jmp     FillPAddr
TXP6:
                mov     eax, DS:pTxStartAddrPage6
FillPAddr:
                mov     [si].TCS_PAddr, eax
                pop     eax
                mov     [si].TCS_Size,0           ;no packet
                mov     si,bx                     ;next block
                add     ax,TxBufferSize           ;start of next buffer
                inc     dl
                ;loop    FillTxBlock
                dec     cx
                jnz     FillTxBlock

                sub     si,SIZE Tx_Control        ;get last block
                mov     [si].TCS_Link, Offset Tx_Cont_Block     ;circular list

                mov     TCSNextToFill, OFFSET Tx_Cont_Block
                        ;fill first block
                mov     TCSNextToXmit, OFFSET Tx_Cont_Block
                        ;fill first block
                mov     TCSNextToTOK, OFFSET Tx_Cont_Block
                mov     dx, DS:NICIMR
                mov     ax, 3FH
                out     dx, ax
                call    Init_CRC32
                pop     eax
                sti
                RET
A_ENDP          ResetNIC




public Overflow_process

A_PROC          Overflow_process ,near

                push    eax

                ;push    ax
                ;mov     al,'O'
                ;call    show_char
                ;pop     ax


        mov     dx, DS:NICRCR
        in      eax, dx

        push    eax

        mov     dx, DS:NICCMD   ; disable rx
        mov     al, CMD_TE
        out     dx, al

        mov     ax, offset DS:RxBufferStartAddr
        mov     CurRxBufAddr, ax                ;reset rx start addr

        WR_NIC  ISR, 40h+ISR_ROK+ISR_RER+ISR_RXOVW ;clear interrupt bit

        mov     DS:RxCAPR, 0fff0h

        mov     dx, DS:NICCMD
        mov     al, CMD_RE+CMD_TE
        out     dx, al

        pop     eax
        or      eax, RESV5

        mov     dx, DS:NICRCR
        out     dx, eax

        pop     eax
                RET
A_ENDP          Overflow_process

COMMENT ^

----------------------------------------------------------------------------
$Name: Give_Packets - Pass received packets to the protocol.
----------------------------------------------------------------------------

$Description:
This routine passes as many packets as it can to the protocol. If
indications are enabled and there are packets on board, it sends a
packet to the protocol. It keeps sending packets until it either runs
out or indications are disabled.

If the routine is unable to give packets because interrupts were disabled,
it clears the Received Packet bit in the ISR anyway. If this were not done,
turning off indications would cause the interrupt routine to loop
forever, since the bit would never be cleared.

If any indications have been sent, it then gives an IndicationComplete
to the protocol. After this has completed, it will try to send more
packets since indications may have been enabled by the IndicationComplete
routine.

Note that this routine is NOT reentant, but it is called from the interrupt
routine which serializes access to it.
$
^
;        GP_Loop:         Indication On ? (IndOffs = 0 ?)
;                 _______________|/_________________
;                |       No      |\                 |
;                |            Yes|                  |
;                |              \|/ (enable int)    |
;                |    +---------------------+       |
;                |    | Check CURR page is  |       |
;                |    | equal to next_pkt ? |       |
;                |    +---------------------+       |
;             ___|_______________| No               |
;            |   |    Yes        |                  |
;            |   |              \|/                 |
;            |   |         DoRecLookAhead           |
;            |   |               |                  |
;            |   |              \|/                 |
;            |   |        Set IndCompFlag = 1       |
;            |   |  (Must do a IndicationComplete)  |
;            |   |               |                  |
;            |   |               +------------------+
;            |   |
;  GP_Clr:   |   +----> Clear Interrupt bit
;            |               (ISR_PRX)
;            |                   |
;            |                   |
;            |                  \|/
;  IndComp:  +--------> Check IndCompFlag &
;                       Clear IndCompFlag
;                          ______|______
;                      1  |             |  0
;                        \|/           \|/
;                       Call        Give_Packets done
;                IndicationComplete

public Give_Packets
A_PROC  Give_Packets    , near
                cli

                WR_NIC  ISR, 40h+ISR_ROK+ISR_RER+ISR_RxOVW ;clear interrupt bit
                
;inserted on 2006/02/16 to debug	begin
;	pushf
;	push	ax
;	mov	al,'R'
;	call	pchar
;	pop	ax
;	popf
;inserted on 2006/02/16 to debug	end

                cmp     ServStat.ms_pktfilter, 0 ; check if reject all frames
                jne     gp_start                 ; no, go for accept
                call    Overflow_process            ; reset the NIC
                ;push    ax
                ;mov     al,'f'
                ;call    show_char1
                ;pop     ax
                ret
gp_start:
gp_loop:
                cli
                mov     dx,DS:NICCMD
                in      al,dx
                test    al,CMD_EMPTY        ;have packets ?
                jz      ReadLookAheadData

                jmp     IndComp             ;no. do IndicationComplete


ReadLookAheadData:
                cli
                mov     ax,cs
                mov     es,ax
                mov     si, DS:CurRxBufAddr
                mov     ax,ds:[si]
                and     al, 3fh
                cmp     al, 01h
                jz      DoRec
                ;push    ax
                ;mov     al,'r'
                ;call    show_char1
                ;pop     ax

                call    Overflow_process
                jmp     indcomp
DoRec:
                call    DoRecLookahead  ;yes. do a ReceiveLookahead.

                mov     IndCompFlag,1   ;Must do a IndicationComplete
                ;jmp     gp_start       ;Try giving more packets

                ;cmp     indoffs,0
                cmp     Indicate, 0
                jne     gp_loop                  ;were indications on?

                mov     dx,DS:NICCMD
                in      al,dx
                test    al,CMD_EMPTY        ;have packets ?
                jnz     IndComp

                mov     si, DS:CurRxBufAddr
                mov     ax,ds:[si]
                and     al, 3fh
                cmp     al,01h          ;(RUNT+CRC+FAE+ISE+LONG)
                jz      Emergency

                ;push    ax
                ;mov     al,'x'
                ;call    show_char
                ;pop     ax

                call    Overflow_process
                jmp     IndComp                  ;no. don't give any more

Emergency:
                call    Overflow_process
                jmp     IndComp


gp_clr:

;give an IndicationComplete if necessary.
;
IndComp:
                mov     al,0            ;test and reset the IndCompFlag
                xchg    al,IndCompFlag
                cmp     al,0            ;was flag set?
                je      gp_done         ;no. We're done

                push    es              ;save es across call
                push    CommChar.cc_moduleid    ;args for IndComplete
                push    ProtDS
                sti
                call    [IndicationComplete]
                pop     es

                ;jmp     gp_start        ;See if we can send any more packets
                ;jmp     gp_loop

gp_done:
;inserted on 2006/02/16 to debug	begin
;	pushf
;	push	ax
;	mov	al,'r'
;	call	pchar
;	pop	ax
;	popf
;inserted on 2006/02/16 to debug	end
                STI
                ret
A_ENDP  Give_Packets



COMMENT ^
----------------------------------------------------------------------------
$Name: DoRecLookahead - Give a ReceiveLookahead to the protocool
----------------------------------------------------------------------------
;ReceiveLookAhead : Indicate arrival of received frame and offer lookahead
;                   data.
$Description:
In this procedure, we will allocate a local LookAheadBuf and by using remote
DMA to get the whole packet data (no matter the packet is wrapped around or
not ?). We also maintain a LookAheadValue (declared in Request.asm) which
will update its value when upper layer call SetLookAhead (In Request), the
initial value of LookAheadValue is 64 and its maximum is 256.
Before calling [ReceiveLookAhead], we will push some parameters and the
parameter - ByteAvail is equal to LookAheadValue. When upper layer view the
look ahead data is what he want then he will call TransferData. Something
important to remember is we can not waste too much time in the procedure
TransferData, so we ready all data from buffer ring into our local buffer
before calling [ReceiveLookAhead].

$
^
L_PROC  DoRecLookahead
;acknowledge the interrupt for the receive

;CX : Packet size, DX : Size of first chunk

;                pkt_data defined in dp8139.inc, 8129 header include
;                packet status(2), length(2)


                mov     LookAhead,si
                MOV     BX,SI                   ;SI=CurRxBufAddr

                Push    DS                      ;set ES is equal to DS
                Pop     ES

                mov     ax, offset DS:RxBufferStartAddr

                add     ax, 2000h               ;Right Now 32768d

                mov     cx, es:[si].pkt_count   ;get RxByteCount
                add     cx, si                  ;get cx length
                add     cx, 7                   ;align 4
                and     cx, 0fffch
                cmp     cx, ax                  ;check next packet will be
                                                ;wraps around ?
                jbe     No_Packet_Wraps         ;No packet wraps around

                push    si                      ;save si=CurRxBufAddr
                mov     di, ax                  ;mov wraps around packets

                mov     si, offset DS:RxBufferStartAddr
                sub     cx, ax                  ;wraps packet counters
                shr     cx,2                    ;
                rep     movsd                   ;mov wraps packet to
                                                ;RxBufferStartAddr
                pop     si                      ;pop si=CurRxBufAddr

No_Packet_Wraps:

                call    DoubleCheck

                mov     si, DS:CurRxBufAddr
                mov     cx,es:[si].pkt_count    ;get CurRxBufAddr packet size
                mov     di,si                   ;di=si
                sub     cx, 4                   ;subtract CRC size

                cmp     DS:ErrorFlag,1
                jne     IndicateJmp

                jmp     NoIndicate

IndicateJmp:


;set up for and call ReceiveLookahead
                mov     Indicate,0FFh           ;protocol will reset this to keep
                inc     IndOffs                 ;turn off indications before
                ;MOV     DX, CX
                ;MOV     DX, 64
                MOV     DX, LookAheadValue
This_Len:
                push    es                      ;save es
                push    CommChar.cc_moduleid;arguments for ReceiveLookahead
                push    CX                      ;size of packet
                PUSH    DX
                LEA     ax,ES:[si].pkt_data     ;start of packet data
                push    es                      ;packet location
                push    ax
                push    ds                      ;address if indicate byte
                pushc   <OFFSET Indicate>
                push    ProtDS                  ;DS of protocol
                sti
                call    [ReceiveLookahead]      ;call the protocol
                pop     es                      ;restore es
                cmp     Indicate, 0             ;turn on indications?
                je      @F                      ;no
                dec     IndOffs                 ;yes

;Update pointers to next packet
@@:

NoIndicate:
                mov     si, DS:CurRxBufAddr  ; Where we read the packet data from
                mov     ax, [si].pkt_count
                add     ax, 7
                and     ax,0fffch
                add     si, ax
                cmp     si, DS:RxBufBoundary
                jb      NoRxWrapFix
                sub     si, 2000h
NoRxWrapFix:
                mov     DS:CurRxBufAddr, si
                mov     dx, DS:NICCAPR
                add     ax,DS:RxCAPR
                mov     DS:RxCAPR, ax
                out     dx, ax

                WR_NIC  ISR, 40h+ISR_ROK+ISR_RER+ISR_RxOVW ;clear interrupt bit

                DWADD   MacStat.ms_RxTotPktCT,1   ;number of packet received
                sub     cx, 4                     ;subtract CRC size
                DWADD   MacStat.ms_RxTotByteCT,CX ;bytes received

                ret                               ;all done.
L_ENDP          DoRecLookahead


COMMENT ^

----------------------------------------------------------------------------
$Name: TransferData - field TransferData request from protocol
----------------------------------------------------------------------------
Calling Procedure:
        PUSH    LPWORD  BytesCopied
        PUSH    WORD    FrameOffset
        PUSH    LPBUF   TDBufDescr
        PUSH    WORD    MacDS
        CALL    TransferData

$Description:
This procedure transfers frame data to the protocol's buffers. We copy
starting at offset FrameOffset within the frame, and copy until either the
packet has been completely copied or we run out of buffer space. The packet
to be copied is still pointed to by next_pkt when this routine is entered.
$
^
A_PROC         TransferData, FAR

BytesCopied     EQU     <DWORD PTR [bp+14d]>
FrameOffset     EQU     <WORD PTR [bp+12d]>
TDBufSeg        EQU     <WORD PTR [bp+10d]>
TDBufDescr      EQU     <DWORD PTR [bp+8d]>
MacDS           EQU     <WORD PTR [bp+6]>
NumCopied       EQU     <WORD PTR [bp-2]>
NumLeft         EQU     <WORD PTR [bp-4]>

                push    bp              ;set up stack frame
                mov     bp,sp
                sub     sp,4d           ;room for locals
                push    es
                push    ds
                push    si
                push    di

                mov     ds,MacDS                ;get our ds
                PUSH    DS
                POP     ES

                mov     si,DS:LookAhead

                mov     ax,es:[si].pkt_count    ;get size of packet
                sub     ax,4                    ;subtract CRC
                sub     ax,FrameOffset          ;subtract starting point
                ja      @F
                mov     ax,INVALID_PARAMETER
                jmp     XferDone

;Our DS will not be available in this routine, so cache the variables that
;we will need.
@@:             mov     NumLeft,ax
                mov     NumCopied,0

                lea     si,es:[si].pkt_data     ;start of packet
                add     si,FrameOffset          ;start of transfer

                les     bx,TDBufDescr           ;get transfer descriptor
                mov     dx, es:[bx].td_blkct    ;number of blocks
                lea     bx, es:[bx].td_datablk  ;offset of data block descriptors

loop1:          cmp     dx,0                    ;all data blocks filled?
                ja      @F                      ;no
                jmp     loopend                 ;yes. We're done

@@:             cmp     NumLeft,0               ;All bytes transferred?
                jne     @F                      ;no. keep going
                jmp     loopend                 ;yes. We're done

@@:             mov     ES, TDBufSeg            ;get buffer descriptor

                mov     cx,ES:[bx].tblk_datalen ;length of buffer

                cmp     ES:[bx].tblk_ptrtype,PHYSTYPE   ;is the pointer physical?
                je      physconv

                les     di,ES:[bx].tblk_datapt          ;no. use virtual addr
                jmp     cpyst

physconv:
IFDEF           DOS
                les     di,ES:[bx].tblk_datapt          ;DOS always uses seg:off format
ELSE                                                    ;OS/2
                ;************************ <OS/2> **************************
                CLI
                push    dx                              ;protected mode stuff
                push    cx
                push    bx
                push    si
                push    ds

                mov     cx, ES:[bx].tblk_datalen        ;length of buffer
                mov     si,segRX
                mov     ax, ES:[bx].tblk_datapt._hi     ;physical address
                mov     bx, ES:[bx].tblk_datapt._lo
                mov     dl,DEVHLP_PHYSTOGDTSEL
                call    ds:Device_Help
                mov     es,si
                xor     di,di

                pop     ds
                pop     si
                pop     bx
                pop     cx
                pop     dx
                ;************************ <OS/2> **************************
ENDIF

cpyst:          cmp     cx,NumLeft
                jbe     @F
                mov     cx,NumLeft

@@:             sub     NumLeft,cx
                add     NumCopied,cx

@@:             shr     cx,1                    ;convert size to words
                pushf
                shr     cx,1                    ;convert size to words
                rep     movsd                   ;transfer block
                jnc     XX1                     ;odd number of bytes?
                movsw                           ;yes. copy last byte
XX1:
                popf
                jnc     xx2
                movsb

XX2:            dec     dx                      ;decrement number of buffers
                add     bx, SIZE Tdatablk       ;increment pointer into TDBufDescr
                jmp     loop1

loopend:        les     di, BytesCopied         ;set bytes copied param
                mov     ax,NumCopied
                mov     ES:[di],ax
                mov     ax,SUCCESS
XferDone:
                pop     di
                pop     si
                pop     ds
                pop     es
                add     sp,4d
                pop     bp
                ret     12d
;==============================================================================
A_ENDP         TransferData


COMMENT ^

------------------------------------------------------------------------
$Name: ReceiveRelease - Return ownership of RcvReq to MAC $
------------------------------------------------------------------------

Calling Procedure:
        PUSH    WORD    ReqHandle       ;Unique handle from ReceiveChain
        PUSH    WORD    MacDS           ;DS of MAC module
        CALL    ReceiveRelease

Return Value:
        AX contains return value. For meaning, see MAC spec.

$Description:
If this is ever called, it must have an invalid parameter, since we never do
a ReceiveChain.
$

$Method:
$
^
A_PROC          ReceiveRelease, FAR
                mov     ax,INVALID_PARAMETER    ;return code
                ret     4
A_ENDP          ReceiveRelease


COMMENT ^

----------------------------------------------------------------------------
$Name: IndicationOn - turn on indications $
----------------------------------------------------------------------------

Calling Sequence:
        PUSH    WORD    MacDS           ;ds of mac module
        CALL    IndicationOn

$Description:
This decrements the indication counter if it is greater than 0. It exits
with interrupts off. Result is returned in AX.
$

$Method:
$
^
A_PROC          IndicationOn, FAR
                CLI
                push    bp
                mov     bp,sp
                push    ds
                mov     ds, WORD PTR [bp+6]

                cmp     IndOffs,0
                je      @F
                dec     IndOffs

@@:             pop     ds
                pop     bp
                mov     ax,SUCCESS
                ret     2
A_ENDP          IndicationOn



COMMENT ^

----------------------------------------------------------------------------
$Name: IndicationOff - turn off indications $
----------------------------------------------------------------------------

Calling Sequence:
        PUSH    WORD    MacDS           ;ds of mac module
        CALL    IndicationOff

$Description:
This turns off indications by incrementing the IndOffs counter. It returns
with interrupts disabled. Result is returned in AX.
$

$Method:
$
^
A_PROC          IndicationOff, FAR
                CLI
                push    bp
                mov     bp,sp
                push    ds
                mov     ds, WORD PTR [bp+6]

                inc     IndOffs
@@:             pop     ds
                pop     bp
                mov     ax,SUCCESS
                ret     2
A_ENDP          IndicationOff



COMMENT ^

----------------------------------------------------------------------------
$Name: Init_Receive - Initialize the receive module
----------------------------------------------------------------------------

$Description:
This routine initializes the receive module. To do this, we need to write
the values of pstart and pstop into our code segment. We use the CSSelector
provided by init for this purpose. The values of RBSTART and CAPR are obtained
from NIC registers. The driver is initialized with indications off. They are
turned on the first time SetPacketFilter is called.
$

$Method:
$
^
PUBLIC      Init_Receive
L_PROC      Init_Receive

        push    ds
        push    es


;get a selector for our CS using PhysToVirt/VirtToPhys, just as in the
;init module. We must put the result is DS rather than ES, because if we
;use ES the selector for our board will be redefined.
IFDEF   DOS
        NOP
ELSE                                    ;OS/2
        ;************************ <OS/2> **************************
        push    ds
        push    ds
        pop     es
        push    cs                      ;mov cs into ds
        pop     ds
        mov     si,0                    ;start of segment
        mov     DL, DEVHLP_VIRTTOPHYS   ;convert CS to physical
        call    es:[Device_Help]           ;phys addr in ax:bx

        pop     ds
        mov     cx,0                    ;64K segment
        mov     dh,0                    ;result in DS
        mov     dl, DEVHLP_PHYSTOVIRT
        call    [Device_Help]

        push    ds                      ;use ES to write values
        pop     es                      ;so linker doesn't complain

        ;************************ <OS/2> **************************
ENDIF
        pop     es                      ;Restore ES
        pop     ds                      ;restore DS

;;SID   mov     IndOffs,1               ;no indications
        mov     IndOffs, 0

        mov     ax,SUCCESS
        ret
L_ENDP          Init_Receive

L_PROC          ReverseBit
        mov     ah,0

        mov     al,TmpByte
        shl     al,7
        and     al, 80h
        or      ah, al

        mov     al,TmpByte
        shl     al,5
        and     al, 40h
        or      ah, al

        mov     al,TmpByte
        shl     al,3
        and     al, 20h
        or      ah, al

        mov     al,TmpByte
        shl     al,1
        and     al, 10h
        or      ah, al


        mov     al,TmpByte
        shr     al,1
        and     al, 08h
        or      ah, al


        mov     al,TmpByte
        shr     al,3
        and     al, 04h
        or      ah, al

        mov     al,TmpByte
        shr     al,5
        and     al, 02h
        or      ah, al

        mov     al,TmpByte
        shr     al,7
        and     al, 01h
        or      ah, al

        mov     TmpByte,ah
        ret
L_ENDP          ReverseBit

L_PROC          Init_CRC32

                lea   si, CRC32_Table
                mov   Count256, 0
                mov   al,12340000h
Init_CRC_loop:
                mov   ax,Count256
                mov   TmpByte, al
                call  ReverseBit
                xor   eax, eax
                mov   al, TmpByte

                mov   cx,8
                shl   eax,24

Init_CRC_loop1:
                test  eax,80000000h
                jz    @F
                shl   eax,1
                xor   eax, 04c11db7h
                jmp   CRC_Next
@@:
                shl   eax,1
CRC_Next:
                loop  Init_CRC_loop1

                mov   TmpDword, eax

                shr   eax,24
                mov   TmpByte, al
                call  ReverseBit
                mov   al, TmpByte
                mov   [si], al
                inc   si


                mov   eax, TmpDword
                shr   eax,16
                and   eax, 0FFh
                mov   TmpByte, al
                call  ReverseBit
                mov   al, TmpByte
                mov   [si], al
                inc   si

                mov   eax, TmpDword
                mov   TmpByte, ah
                call  ReverseBit
                mov   al, TmpByte
                mov   [si], al
                inc   si

                mov   eax, TmpDword
                mov   TmpByte, al
                call  ReverseBit
                mov   al, TmpByte
                mov   [si], al
                inc   si
                inc   Count256
                cmp   Count256,256
                jne   Init_CRC_loop
                mov    cx,256
                lea    di, CRC32_Table                ;first address
                ret

L_ENDP          Init_CRC32



L_PROC          DoubleCheck
                push   cx
                push   si

                mov     DS:ErrorFlag,0
                mov     DS:CRC32, 0ffffffffh
                mov     si, DS:CurRxBufAddr
                mov     cx, word ptr [si+2]             ;get RxByteCount
                sub     cx, 4
                add     si, 4
loop_crc:
                cmp     cx,0                            ;all addrs processed?
                jne     @F                              ;no
                jmp     crc_done                        ;yes. We're done
@@:             xor     edx, edx
                mov     dl, [si]                        ;get address byte
                mov     eax,DS:CRC32
                xor     eax, edx
                and     eax, 0ffh
                lea     di, DS:CRC32_Table                ;first address
                shl     ax ,2
                add     di, ax
                mov     edx, dword ptr [di]
                mov     eax, DS:CRC32
                shr     eax, 8
                xor     eax, edx
                mov     DS:CRC32, eax
                dec     cx
                inc     si
                jmp     loop_crc
crc_done:
                mov     si, DS:CurRxBufAddr

                mov     cx, word ptr [si+2]   ;get RxByteCount
                add     si,cx
                mov     ebx, DS:CRC32
                not     ebx
                mov     eax, dword ptr [si]
                cmp     eax, ebx
                je      @F
                mov     DS:ErrorFlag,1

@@:

                pop  si
                pop  cx
                ret
L_ENDP          DoubleCheck



CODESEG_END
END
