COMMENT  ^
This file contains code for the system request functions. The only function
supported by the MAC is Bind.
^

IFNDEF  DOS                    ;286 protected mode needed to
.286P                          ;examine machine status word
ENDIF                          ;under OS/2
INCLUDE macros.inc
INCLUDE vector.inc
INCLUDE os2defs.inc
INCLUDE RTL8139.inc
INCLUDE dp8139.inc
INCLUDE dosopen.inc
;errors. Each procedure sets AX to the appropriate value if it fails.

MEM_ERR            equ    1 ;memory test error
BAD_ID             equ    2 ;Bad Ethernet ID

;==============================================================================
DATASEG_BEG
EXTRN    TransmitConfirm:DWORD, ReceiveLookahead:DWORD,ServChar:WORD
EXTRN    IndicationComplete:DWORD, CommChar:WORD, ServStat:WORD
EXTRN    Status:DWORD, RequestConfirm: DWORD,  RemoteBuffer:BYTE
EXTRN    BrdNum:Byte,NetAddr:WORD,NetAddress:word,NetFlag:byte
EXTRN    RxBufferStartAddr:byte,NICIDR0:word,NICIDR4:word
EXTRN    NICTCR:word,NICCMD:word,NICIMR:WORD,NICCR9346:word
EXTRN    TxStartAddrPage0:byte
EXTRN    Device_Help:DWORD

PUBLIC  ProtDS
ProtDS          dw      ?               ;data segment of protocol
Err_Count       dw      0

errdescr2       dw      offset DGROUP:serr1, serr2 - serr1
                dw      offset DGROUP:serr2, serr3 - serr2


serr1   db      " The Fast Ethernet board's memory has some bad cells - could not work properly",0dh,0ah,0ah
serr2   db      " The Fast Ethernet Board's Ethernet Address is corrupted ! ",0dh,0ah,0aH
serr3   label   byte

EtherIDMSG       db   "Fast Ethernet board's Ethernet Address:"

EthernetAddrStr db   '00000000000B',0dh,0ah
EtherIDMSGLen   equ  $-EtherIDMSG


DATASEG_END
;==============================================================================
CODESEG_BEG

EXTRN SetInterrupt:NEAR,IntCheck:NEAR,Init_int:near,Init_receive:near
EXTRN IOBASE:WORD
EXTRN ResetNIC:near;
IFNDEF  DOS
EXTRN   DOSPUTMESSAGE:FAR,DOSOPEN:FAR
ENDIF


COMMENT ^

-----------------------------------------------------------------------------
$Name: HWInit - Initialize the 8129 on the board
-----------------------------------------------------------------------------
$Description:
This function sets up the 8129 chip. It initializes all the 8029
registers, as per the 8129 Data Sheet. It sets BNRY=PSTART and
CURR=BNRY+1. It leaves the 8129 in STOP mode set up for internal
loopback. The chip is brought on line at bind time. It does not touch
the ISR. An interrupt is still pending there from our loopbacks while
determining memory size. We need this interrupt for the IntCheck
routine run later in init and at bind time.
$

$Method:
$
^
public   HWInit
L_PROC   HWInit


        Call    GetBoardAddr            ;get Board Ethernet ID

        mov     ax,0

IFDEF   DOS
        NOP
ELSE                                    ;OS/2
        ;************************ <OS/2> **************************
        ; Subject : Change the value in Code segment
        ;----------------------------------------------------------
        ; NOTE : You can not modify the value in Code segment
        ;        directly under OS/2
        ;----------------------------------------------------------
        PUSH    DS                      ;reserve ds
        PUSH    ES                      ;reserve es

        push    ds                      ;mov ds into es
        pop     es
        push    cs                      ;mov cs into ds
        pop     ds
        mov     si,0                    ;start of segment
        mov     DL, DEVHLP_VIRTTOPHYS   ;convert CS to physical
        call    es:[Device_Help]           ;phys addr in ax:bx

        mov     cx,0                    ;64K segment
        mov     dh,0                    ;result in DS
        mov     dl, DEVHLP_PHYSTOVIRT
        call    es:[Device_Help]

        push    ds                      ;use ES to write values
        pop     es                      ;so linker doesn't complain



        POP     ES                      ;recover ES
        POP     DS                      ;recover DS
        ;************************ <OS/2> **************************
ENDIF

DoneHWInit:

        MOV     AX,0
        ret

L_ENDP  HWInit



COMMENT ^

----------------------------------------------------------------------------
$Name: GetBoardAddr - Put the board address into the tables
----------------------------------------------------------------------------
$Description:
This routine reads the ethernet address from the PROM on the board and writes
it into the tables of the driver.
$

$Method:
$
^

L_PROC          GetBoardAddr

        pusha
        push    eax

        cmp     NetFlag,1
        jne     Not_Net_Addr

;5/22/98 Checking netaddress value is a 0 to F .

        lea     si,DS:netaddr
        mov     cx,12
        mov     bx,9
Check_ID:
        mov     al,[si]
        cmp     al,30h                  ;0
        jb      Not_Net_Addr
        cmp     al,46h                  ;F
        ja      Not_Net_Addr1
        jmp     @F

Not_Net_Addr1:
        cmp     al,61h                  ;a
        jae     check_a
        jmp     Not_Net_Addr
check_a:
        cmp     al,66h                  ;f
        jbe     @F
        jmp     Not_Net_Addr

@@:
        inc     si
        cmp     bx,cx
        jne     @F
        sub     bx,4
        inc     si
@@:
        loop    Check_ID                ;0 - F





;5/22/98 Checking netaddress value is a 0 to F .

        mov     DX,DS:NICCR9346
        in      al,dx
        or      al,0c0h
        out     dx,al
        xor     eax,eax

        lea     si,DS:netaddress
        mov     dx,DS:NICIDR0
        mov     al,byte ptr [si+4]
        mov     ah,byte ptr [si+6]
        shl     eax,16

        mov     al,byte ptr [si]
        mov     ah,byte ptr [si+2]

        out     dx,eax

        mov     al,byte ptr [si+8]
        mov     ah,byte ptr [si+10]

        mov     dx,DS:NICIDR4
        out     dx,ax

        mov     DX,DS:NICCR9346
        in      al,dx
        and     al,3fh
        out     dx,al


Not_Net_Addr:

        push    DS                              ;make ES is equal to DS
        pop     ES                              ;
        lea     si,DS:RemoteBuffer

        mov      dx,DS:NICIDR0
        in       eax,dx
        mov      [si],al
        mov      [si+2],ah
        shr      eax,16
        mov      [si+4],al
        mov      [si+6],ah

        mov      dx,DS:NICIDR4
        in       ax,dx
        MOV      [si+8],al
        MOV      [si+10],ah

        mov     cx,6
        mov     di,offset DGROUP:EthernetAddrStr
        lea     si, DS:RemoteBuffer                ;setup ES:DI for dest.



praddr:
        mov     bl, byte ptr [si]          ;get one byte of addr.
        mov     dl, 0FH
        mov     dh, 0F0H
        and     dh, bl                     ;upper four bits
        and     dl, bl                     ;lower four bits
        shr     dh, 1                      ;div 16
        shr     dh, 1
        shr     dh, 1
        shr     dh, 1
        cmp     dh, 9
        jg      a1
        add     dh, '0'
        jmp     a2
a1:     add     dh, 'A'-10
a2:     mov     [di], dh
        cmp     dl, 9
        jg      a3
        add     dl, '0'
        jmp     a4
a3:     add     dl, 'A'-10
a4:     mov     [di+1], dl
        inc     si
        inc     si
        inc     di
        inc     di
        loop    praddr

  IFDEF  DOS                                ;DOS
                pushc   <WORD PTR STDOUT>               ;output error description
                pushc   <WORD PTR EtherIDMSGLen>
                push    ds
                pushc   <OFFSET DGROUP:EtherIDMSG>                  ;desription message
                call    DOSPUTMESSAGE
  ENDIF                                      ;OS/2
; ;Check Node ID



@@:             mov     si, OFFSET ServChar.mc_cursnpa  ;current address loc
                mov     di, OFFSET ServChar.mc_permsnpa ;permanent address loc
                cmp     NetFlag,1
                je      NetAddr_Val

                mov     al, Byte Ptr RemoteBuffer[0]    ;first address byte
                mov     ds:[si],al
                mov     ds:[di],al
                mov     al, Byte Ptr RemoteBuffer[2]    ;2nd address byte
                mov     ds:[si+1],al
                mov     ds:[di+1],al
                mov     al, Byte Ptr RemoteBuffer[4]    ;3rd address byte
                mov     ds:[si+2],al
                mov     ds:[di+2],al
                mov     al, Byte Ptr RemoteBuffer[6]    ;4th address byte
                mov     ds:[si+3],al
                mov     ds:[di+3],al
                mov     al, Byte Ptr RemoteBuffer[8]    ;5th address byte
                mov     ds:[si+4],al
                mov     ds:[di+4],al
                mov     al, Byte Ptr RemoteBuffer[10]   ;6th address byte
                mov     ds:[si+5],al
                mov     ds:[di+5],al
                jmp     @F
NetAddr_Val:
                mov     al, Byte Ptr NetAddress[0]    ;first address byte
                mov     ds:[si],al
                mov     ds:[di],al
                mov     al, Byte Ptr NetAddress[2]    ;2nd address byte
                mov     ds:[si+1],al
                mov     ds:[di+1],al
                mov     al, Byte Ptr NetAddress[4]    ;3rd address byte
                mov     ds:[si+2],al
                mov     ds:[di+2],al
                mov     al, Byte Ptr NetAddress[6]    ;4th address byte
                mov     ds:[si+3],al
                mov     ds:[di+3],al
                mov     al, Byte Ptr NetAddress[8]    ;5th address byte
                mov     ds:[si+4],al
                mov     ds:[di+4],al
                mov     al, Byte Ptr NetAddress[10]   ;6th address byte
                mov     ds:[si+5],al
                mov     ds:[di+5],al
@@:
                pop     eax
                popa
                mov     ax,0
                ret


L_ENDP          GetBoardAddr

IFDEF DOS                                    ;DOS

COMMENT ^

----------------------------------------------------------------------------
$Name: DOSPUTMESSAGE - put a message on the screen
----------------------------------------------------------------------------

$Description:
This function is used in DOS to perform the function of DOSPUTMESSAGE in OS/2.
It takes the same arguments (on the stack) as the OS/2 call.
$

$Method:
$
^

;   Stack status
;
;                |           |___ bp
;              2 |    bp     |
;              2 |   Call    |___ bp+4
;              2 |  Offset   |
;              2 |  Segment  |___ bp+8
;              2 |  Length   |
;              2 |  StdOut   |
;                +-----------+

L_PROC          DOSPUTMESSAGE
                push    bp
                mov     bp,sp           ;setup stack
                mov     cx,[bp+8]       ;length
                mov     bx,[bp+4]       ;message offset
                mov     ah,2            ;display output call
putloop:        mov     dl,[bx]         ;print string
                int     21h
                inc     bx
                loop    putloop
                pop     bp
                mov     ax,0
                ret     8
L_ENDP          DOSPUTMESSAGE

ENDIF

COMMENT ^

----------------------------------------------------------------------------
$Name: Bind - exchange module characteristic table information$
----------------------------------------------------------------------------
$Description:
This handle the binds system request. It puts the address of our Common
Characteristics table in the location specified by the parameter. It then
examines the protocols characteristics tables to extract the information
we are interested in.

Bind also takes the 8129 chip out of loopback mode and starts it up. This
is done to prevent the reception of any packet until binding is done.
$

$Method:
The stack has already been set up by the System procedure, which also deals
with saving registers.
$
^
;------------------------------------------------------------------------------
;                       PROCEDURE NAME --- Bind
;------------------------------------------------------------------------------
L_PROC  Bind

TabAddr         EQU     <DWORD PTR [bp+12d]>
CharTab         EQU     <DWORD PTR [bp+16d]>

;see if we're already bound

        test    ServStat.ms_status._lo, MSMSK_MACBOUND
        jz      @F                      ;not bound
        mov     ax, INVALID_FUNCTION    ;already bound
        ret

@@:
        push    ds
        call    HWInit
        pop     ds
        or      ax,ax
        jz      @F

IFDEF   DOS                                ;DOS
        mov     bx,ax
        sub     bx,1
        shl     bx,1                          ;index into error description table
        shl     bx,1
        pushc   <WORD PTR STDOUT>               ;output error description
        mov     ax, DGROUP:errdescr2[bx]+2      ;description length7
        push    ax
        push    ds
        mov     ax, DGROUP:errdescr2[bx]  ;desriptionmessage
        push    ax
        call    DOSPUTMESSAGE
ENDIF
        mov     ax, HARDWARE_FAILURE    ;already bound
        ret

 @@:
 ;------ Initialize receiver

        call    Init_receive
        call    init_int


;give him address of our Common Characteristics table

@@:     les     di,TabAddr
        mov     ES:[di]._off, OFFSET CommChar
        mov     ax,CommChar.cc_dataseg
        mov     ES:[di]._seg, ax

;get the parameters we want
        les     di,CharTab                     ;his common char table
        mov     ax, ES:[di].cc_dataseg         ;get his data segment
        mov     ProtDS,ax                      ;protocol segment

        les     di, ES:[di].cc_ldtpt           ;his lower dispatch table

        mov     ax,ES:[di].pl_xmtconfirm._off  ;TransmitConfirm address
        mov     TransmitConfirm._off,ax
        mov     ax,ES:[di].pl_xmtconfirm._seg
        mov     TransmitConfirm._seg,ax

        mov     ax,ES:[di].pl_rcvlookahead._off;ReceiveLookahead address
        mov     ReceiveLookahead._off,ax
        mov     ax,ES:[di].pl_rcvlookahead._seg
        mov     ReceiveLookahead._seg,ax

        mov     ax,ES:[di].pl_indcomplete._off  ;IndicationComplete address
        mov     IndicationComplete._off,ax
        mov     ax,ES:[di].pl_indcomplete._seg
        mov     IndicationComplete._seg,ax

        mov     ax,ES:[di].pl_reqconfirm._off  ;RequestConfirm address
        mov     RequestConfirm._off,ax
        mov     ax,ES:[di].pl_reqconfirm._seg
        mov     RequestConfirm._seg,ax

        mov     ax,ES:[di].pl_statusind._off  ;Status address
        mov     Status._off,ax
        mov     ax,ES:[di].pl_statusind._seg
        mov     Status._seg,ax

        or      ServStat.ms_status._lo, MSMSK_MACBOUND  ;set bound bit

        call    ResetNIC
        call    SetInterrupt           ;enable int. processing

        mov     ax, SUCCESS


        ret

L_ENDP  Bind

COMMENT ^
----------------------------------------------------------------------------
$Name: System - handle system request functions$
----------------------------------------------------------------------------

Calling Sequence:
        PUSH    DWORD   Param1
        PUSH    DWORD   Param2
        PUSH    WORD    Param3
        PUSH    WORD    Opcode
        PUSH    WORD    TargetDS
        CALL    System

$Description:
Handle system calls. The only one which MACs support is the Bind call.
This procedure sets up the stack and saves variables.
$

$Method:
$

^

A_PROC          System, FAR

Opcode          EQU     <WORD PTR [bp+8]>
TargetDS        EQU     <WORD PTR [bp+6]>


; Stack status                      ___ bp
;                  2 |    bp       |
;                  4 | Call System |___ bp+6
;                  2 |  TargetDS   |___ bp+8
;                  2 |   Opcode    |
;                  2 |   Param3    |___ bp+12
;                  4 |   Param2    |___ bp+16  TabAddr
;                  4 |   Param1    |           CharTab
;                    +-------------+
                push    bp              ;set up stack
                mov     bp,sp           ;get bp=sp

                push    si              ;save reg.
                push    di
                push    ds

                mov     ds,TargetDS     ;get our DS

                cmp     Opcode, VEC_BIND        ;is it a bind request? (2)
                je      @F
                mov     ax,INVALID_FUNCTION     ;no. error.
                jmp     clean

@@:

                call    Bind            ;yes
clean:
                pop     ds              ; clean stack
                pop     di
                pop     si
                pop     bp
                ret     14d
A_ENDP          System

CODESEG_END
;==============================================================================
INITCODESEG_BEG

COMMENT ^

----------------------------------------------------------------------------
$Name: Init_System - Initialize the System module
----------------------------------------------------------------------------

$Description:
This routine initializes the System module. It does nothing currently.
$

$Method:
$
^
A_PROC          Init_System

                mov     ax,SUCCESS
                ret
A_ENDP          Init_System


INITCODESEG_END

END
