;------------------------------------------------------------------------------
;			STRUCTURE NAME --- ReqBlock
;------------------------------------------------------------------------------
;protocol manager request block (This block maybe accessed via IOCTL in OS/2

ReqBlock	STRUC
pm_opcode	dw	?    ;Opcode for Protocol Manager request
pm_status	dw	?    ;status at completion of request
pm_ptr1 	dd	?    ;first parameter Ring 0 GDT pointer
pm_ptr2 	dd	?    ;second parameter Ring 0 GDT pointer
pm_word1	dw	?    ;parameter word
ReqBlock	ENDS
;------------------------------------------------------------------------------
;		     STRUCTURE NAME --- ConfigMemoryImage
;------------------------------------------------------------------------------
;configuration memory image

ConfigMemoryImage	STRUC
mi_moduleconfig 	dw	 ?
ConfigMemoryImage	ENDS
;------------------------------------------------------------------------------
;		      STRUCTURE NAME --- ModuleConfig
;------------------------------------------------------------------------------
;Define the memory image for configuration parameters corresponding to
;one (bracked name) module.
; mc_next
; a FAR pointer to next module configuration structure (For OS/2 the selector
; is Ring 3 INIT time selector. For DOS is segment:offset pair)
; mc_prev
; the same meaning as mc_next, but for previous module
; mc_name
; ASCIIZ string for module name (15 non-null uppercase characters)
; mc_keyword
; keyword line
ModuleConfig	STRUC
mc_next 	dd	?
mc_prev 	dd	?
mc_name 	db	16 dup (?)
mc_keyword	dw	?
ModuleConfig	ENDS
;------------------------------------------------------------------------------
;		      STRUCTURE NAME --- KeywordEntry
;------------------------------------------------------------------------------
KeywordEntry	STRUC
kw_next 	dd	?
kw_prev 	dd	?
kw_keyword	db	16 dup (?)
kw_numparam	dw	?
kw_param	dw	?
KeywordEntry	ENDS
;------------------------------------------------------------------------------
;parameter types
PARAM_NUM	EQU	0
PARAM_STRING	EQU	1
;------------------------------------------------------------------------------
;		       STRUCTURE NAME --- ParamNum
;------------------------------------------------------------------------------
ParamNum	STRUC
pm_type 	dw	?
pm_len		dw	?
pm_num		dd	?
ParamNum	ENDS
;------------------------------------------------------------------------------
;		      STRUCTURE NAME --- ParamString
;------------------------------------------------------------------------------
ParamString	STRUC
		dw	?,?
pm_string	db	?
ParamString	ENDS

